package AztecTemple_Siege {
// ---------------------------------------------------------------------------- begin AztecTemple_Siege package ---

//---------------------------------------------------------------------------------- SiegeGame::gameOver ---

function SiegeGame::gameOver( %game )
{	
   deactivatePackage(AztecTemple_Siege);
   error("SiegeGame::gameOver - deacitavting AztecTemple_Siege package");
   SiegeGame::gameOver( %game );
}

//--------------------------------------------------------------------- SiegeGame::claimFlipflopResources ---

function SiegeGame::claimFlipflopResources(%game, %flipflop, %team)
{
   //%defTeam = game.offenseTeam == 1 ? 2 : 1;

   %group = %flipflop.getGroup();
   %group.setTeam(%team);

   //set the waypoint to the appropriate team
   if(%flipflop.waypoint)
   {
      %wayPoint = %flipflop.waypoint;
      game.switchWaypoint(%wayPoint);
   }
   
   // make this always visible in the commander map (gets reset when sensor group gets changed)
   setTargetAlwaysVisMask(%flipflop.getTarget(), 0xffffffff);

   //lets do custom spawning stuff here
   if (%flipflop == nameToId("AltarSwitch"))
   {
      if (%team == Game.defenseTeam)
      {
         //error("SiegeGame::claimFlipflopResources - DEFENSE CLAIMS ALTAR");

         // ----------------------------- BOTH GEN ROOMS ARE UP DEFENSE MAY SPAWN AT ALTAR

         if (nameToId("TempleBase").powerCount > 0 && nameToId("ObjectiveGroup").powerCount > 0)
         {
            nameToId("TempleSpawn1").sphereWeight = 100;//--- defense base spawn 1
            nameToId("AltarDefense").sphereWeight = 100;//--- defense altar spawn

            //error("SiegeGame::claimFlipflopResources - BOTH GEN ROOMS ARE UP DEFENSE MAY SPAWN AT ALTAR");
         }

         //SiegeGame::claimSpawn(%game, %obj, %newTeam, %oldTeam)

         // --------------- OFFENSE WILL ONLY SPAWN AT VBASE

         nameToId("VBaseSpawn").sphereWeight = 100;//---------- offense vbase spawn
         nameToId("AltarOffense").sphereWeight = 0;//----- offense altar spawn

         //error("SiegeGame::claimFlipflopResources - OFFENSE WILL ONLY SPAWN AT VBASE");
      }
      else if (%team == game.offenseTeam)
      {
         //error("SiegeGame::claimFlipflopResources - OFFENSE CLAIMS ALTAR");

         nameToId("AltarOffense").sphereWeight = 100;//--- offense altar spawn
         
         if (nameToId("TempleBase").powerCount > 0 && nameToId("ObjectiveGroup").powerCount > 0)
         {
            nameToId("VBaseSpawn").sphereWeight = 10;//---------- offense vbase spawn
            //error("SiegeGame::claimFlipflopResources - BOTH GEN ROOMS ARE UP OFFENSE MAY SPAWN AT ALTAR");
         }
         else
         {
            nameToId("VBaseSpawn").sphereWeight = 0;//---------- offense vbase spawn
            //error("SiegeGame::claimFlipflopResources - BOTH GEN ROOMS NOT UP OFFENSE WILL ONLY SPAWN AT ALTAR");
         }
        
         nameToId("AltarDefense").sphereWeight = 0;//----- defense altar spawn
      }
   }

   //update the teleporters holo
   checklogostatus(nameToId("AltarTeleport"));
   checklogostatus(nameToId("TempleTeleport"));   
}


//---------------------------------------------------------------------------------------------- FlipFlop::playerTouch ---

function FlipFlop::playerTouch(%data, %flipflop, %player)
{
   %client = %player.client;
   %flipTeam = %flipflop.team;

   if(%flipTeam == %client.team)
      return false;

   %defTeam = Game.offenseTeam == 1 ? 2 : 1;

   if (%flipflop == nameToId("ObjectiveSwitch"))
   {
      if(%player.team != Game.offenseTeam)
      return;

      //%defTeam = Game.offenseTeam == 1 ? 2 : 1;
      Game.capPlayer[Game.offenseTeam] = stripChars( getTaggedString( %player.client.name ), "\cp\co\c6\c7\c8\c9" );

      // Let the observers know:
      messageTeam( 0, 'MsgSiegeTouchFlipFlop', '\c2%1 captured the %2 base!~wfx/misc/flipflop_taken.wav', %player.client.name, $TeamName[%defTeam] );

      // Let the teammates know:
      messageTeam( %player.team, 'MsgSiegeTouchFlipFlop', '\c2%1 captured the %2 base!~wfx/misc/flipflop_taken.wav', %player.client.name, $TeamName[%defTeam] );

      // Let the other team know:
      %losers = %player.team == 1 ? 2 : 1;
      messageTeam( %losers, 'MsgSiegeTouchFlipFlop', '\c2%1 captured the %2 base!~wfx/misc/flipflop_lost.wav', %player.client.name, $TeamName[%defTeam]);

      logEcho(%player.client.nameBase@" (pl "@%player@"/cl "@%player.client@") captured team "@%defTeam@" base");
       
      Game.allObjectivesCompleted();
   }
   else if (%flipflop == nameToId("AltarSwitch")) 
   {
      %teamName = game.getTeamName(%client.team);

      // Let the observers know:
      messageTeam( 0, 'MsgClaimFlipFlop', '\c2%1 claimed %2 for %3.~wfx/misc/flipflop_taken.wav', %client.name, Game.cleanWord( %flipflop.name ), %teamName );

      // Let the teammates know:
      messageTeam( %client.team, 'MsgClaimFlipFlop', '\c2%1 claimed %2 for %3.~wfx/misc/flipflop_taken.wav', %client.name, Game.cleanWord( %flipflop.name ), %teamName );

      // Let the other team know:
      %losers = %client.team == 1 ? 2 : 1;
      messageTeam( %losers, 'MsgClaimFlipFlop', '\c2%1 claimed %2 for %3.~wfx/misc/flipflop_lost.wav', %client.name, Game.cleanWord( %flipflop.name ), %teamName );

      logEcho(%client.nameBase@" (pl "@%player@"/cl "@%client@") claimed flipflop "@%flipflop@" for team "@%client.team);

      //change the skin on the switch to claiming team's logo
      setTargetSkin(%flipflop.getTarget(), game.getTeamSkin(%player.team));
      setTargetSensorGroup(%flipflop.getTarget(), %player.team);

      // if there is a "projector" associated with this flipflop, put the claiming team's logo there
      if(%flipflop.projector > 0)
      {
         %projector = %flipflop.projector;
         // axe the old projected holo, if one exists
         if(%projector.holo > 0)
            %projector.holo.delete();
          
         %newHolo = getTaggedString(game.getTeamSkin(%client.team)) @ "Logo";

         %projTransform = %projector.getTransform();

         // below two functions are from deployables.cs
         %projRot = rotFromTransform(%projTransform);
         %projPos = posFromTransform(%projTransform);

         // place the holo above the projector (default 10 meters)
         %hHeight = %projector.holoHeight;
         if(%hHeight $= "")
            %hHeight = 10;
         %holoZ = getWord(%projPos, 2) + %hHeight;
         %holoPos = firstWord(%projPos) SPC getWord(%projPos,1) SPC %holoZ;

         %holo = new StaticShape() 
         {
            rotation = %projRot;
            position = %holoPos;
            dataBlock = %newHolo;
         };
         // dump the hologram into MissionCleanup
         MissionCleanup.add(%holo);

         // associate the holo with the projector
         %projector.holo = %holo;
      }

      // convert the resources associated with the flipflop
      Game.claimFlipflopResources(%flipflop, %client.team);
      
      //call the ai function
      Game.AIplayerCaptureFlipFlop(%player, %flipflop);
      return true;
   }
}

//--------------------------------------------------------------------------------------- FlipFlop::objectiveInit ---

function FlipFlop::objectiveInit(%data, %flipflop)
{
   %defTeam = game.offenseTeam == 1 ? 2 : 1;

   //error("FlipFlop::objectiveInit - DefenseTeam = " @ %defTeam);

   if (%flipflop == nameToId("ObjectiveSwitch"))
   {
      Game.regObjective(%flipflop);
      setTargetSkin(%flipflop.getTarget(), $teamSkin[%defTeam]);//set to team skin
   }
   else if (%flipflop == nameToId("AltarSwitch"))
   {
      // add this flipflop to missioncleanup
      %flipflopSet = nameToID("MissionCleanup/FlipFlops");

      if(%flipflopSet <= 0)
      {
         %flipflopSet = new SimSet("FlipFlops");
         MissionCleanup.add(%flipflopSet);
      }
      %flipflopSet.add(%flipflop);

      // see if there's a holo projector associated with this flipflop
      // search the flipflop's folder for a holo projector
      // if one exists, associate it with the flipflop

      %flipflop.projector = 0;
      %folder = %flipflop.getGroup();
      for(%i = 0; %i < %folder.getCount(); %i++) 
      {
         %proj = %folder.getObject(%i);
         // weird, but line below prevents console error
         if(%proj.getClassName() !$= "SimGroup" && %proj.getClassName() !$= "InteriorInstance")
            if(%proj.getDatablock().getName() $= "LogoProjector") 
            {
               %flipflop.projector = %proj;
               %flipflop.projector.holo = 0;//set to team skin
               break;
            }
      }

      // may have been hidden
      %target = %flipFlop.getTarget();

      if(%target != -1)
      {
         // set flipflop to team skin
         setTargetSkin(%target, $teamSkin[%defTeam]);//set to team skin

         // make this always visible in the commander map
         setTargetAlwaysVisMask(%target, 0xffffffff);

         // make this always visible in the commander list
         setTargetRenderMask(%target, getTargetRenderMask(%target) | $TargetInfo::CommanderListRender);
      }
   }
}

//--------------------------------------------------------------------------------------- SiegeGame::AIplayerCaptureFlipFlop ---

function SiegeGame::AIplayerCaptureFlipFlop(%game, %player, %flipFlop)
{
  //do nothing 
}

//--------------------------------------------------------------------------------------- SiegeGame::missionLoadDone ---

function SiegeGame::missionLoadDone(%game)
{

   nameToId("TempleSpawn1").sphereWeight = 100;//--- defense base spawn 1
   nameToId("TempleSpawn2").sphereWeight = 100;//--- defense base spawn 2
   nameToId("AltarDefense").sphereWeight = 100;//--- defense altar spawn
   nameToId("VBaseSpawn").sphereWeight = 100;//---------- offense vbase spawn
   nameToId("AltarOffense").sphereWeight = 0;//----- offense altar spawn
	
   Parent::missionLoadDone(%game);

   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;

   error("SiegeGame::missionLoadDone - DefenseTeam = " @ Game.defenseTeam);
}

//----------------------------------------------------------------------------------------- Generator::onDisabled ---
function Generator::onDisabled(%data, %obj)
{
   Parent::onDisabled(%data, %obj);

   if (%obj.getGroup() == nameToId("TempleBase"))
   {
      if (nameToId("TempleBase").powerCount == 0)
      {
         //flip the generator waypoint
         game.switchWaypoint(nameToId("TempleGenWayPoint"));
		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               if (nameToId("ObjectiveGroup").powerCount == 0)
               { 
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/low-level1-sharp.wav');
                  bottomPrint(%client, "<color:FF0000>\RED ALERT - Objective Switch Exposed - RED ALERT", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/wow-level1-suspended.wav');
                  bottomPrint(%client, "<color:FF0000>\Temple Generators Destroyed - Emergency Spawns Active", 5, 3);
               }
            }
            else if (%client.team == Game.offenseTeam)
            {
               if (nameToId("ObjectiveGroup").powerCount == 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/low-level3-whipped.wav');//works
                  bottomPrint(%client, "<color:8BBD03>\Shrine Switch Exposed", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/low-level4-popping.wav');//works
                  bottomPrint(%client, "<color:8BBD03>\Temple Generators Destroyed", 5, 3);
               }
            }   
         }

         //change the spawn weights
         nameToId("TempleSpawn1").sphereWeight = 0;//--- defense base spawn 1
         nameToId("AltarDefense").sphereWeight = 0;//--- defense altar spawn

         //error("Generator::onDisabled - DEFENSE SPAWN ONLY SPAWN 2");

         //if offense owns the altar spawn them there
         if (nameToId("AltarSwitch").team == Game.offenseTeam)
         {
            nameToId("AltarOffense").sphereWeight = 100;
            nameToId("VBaseSpawn").sphereWeight = 0;//---------- offense vbase spawn

            //error("Generator::onDisabled - OFFENSE ONLY SPAWN AT ALTAR");
         }
      }
   }

   else if (%obj.getGroup() == nameToId("ObjectiveGroup"))
   {
      if (nameToId("ObjectiveGroup").powerCount == 0)
      {
         //flip the generator waypoint
         game.switchWaypoint(nameToId("ObjectiveGenWaypoint"));

         //send messages to the nice people		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               if (nameToId("TempleBase").powerCount == 0)
               { 
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/low-level1-sharp.wav');
                  bottomPrint(%client, "<color:FF0000>\RED ALERT - Objective Switch Exposed - RED ALERT", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/low-level2-spitting.wav');
                  bottomPrint(%client, "<color:FF5500>\ALERT - Shrine Generators Destroyed - ALERT", 3, 2);
               }
            }
            else if (%client.team == Game.offenseTeam)
            {
               if (nameToId("TempleBase").powerCount == 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/high-level4-blazing.wav');
                  bottomPrint(%client, "<color:8BBD03>\Objective Switch Exposed", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/med-level3-shining.wav');
                  bottomPrint(%client, "<color:8BBD03>\Shrine Generators Destroyed", 3, 2);
               }
            }
         }

         //change the spawn weights
         nameToId("TempleSpawn1").sphereWeight = 0;//--- defense base spawn 1
         nameToId("AltarDefense").sphereWeight = 0;//--- defense altar spawn

         //error("Generator::onDisabled - DEFENSE SPAWN ONLY SPAWN 2");

         //if offense owns the altar spawn them there
         if (nameToId("AltarSwitch").team == Game.offenseTeam)
         {
            nameToId("AltarOffense").sphereWeight = 100;
            nameToId("VBaseSpawn").sphereWeight = 0;//---------- offense vbase spawn

            //error("Generator::onDisabled - OFFENSE ONLY SPAWN ALTAR");
         }
      }
   }
   //---------------------------------------------------------------------- Entrance FF Solar Panels
   else if (%obj == nameToId("EntranceSolarPanelEast") || %obj == nameToId("EntranceSolarPanelWest"))
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
         {
            messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
            bottomPrint(%client, "<color:FFFF00>\WARNING - Entrance Force Field Compromised - WARNING", 2, 2);
         }
         else if (%client.team == Game.offenseTeam)
         {
            messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/captain.wav');
            bottomPrint(%client, "<color:8BBD03>\- Entrance Force Field Compromised -", 2, 2);
         }
      }
   }
}

//--------------------------------------------------------------------------------------- Generator::onEnabled ---
function Generator::onEnabled(%data, %obj, %prevState)
{
   Parent::onEnabled(%data, %obj, %prevState);

   // ---------------------------------------------------- Temple Base Gens
   if (%obj.getGroup() == nameToId("TempleBase"))
   {
      if (nameToId("TempleBase").powerCount < 2)
      {
         //flip the generator waypoint
         game.switchWaypoint(nameToId("TempleGenWayPoint"));
	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               if (nameToId("ObjectiveGroup").powerCount > 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/low-level2-spitting.wav');
                  bottomPrint(%client, "<color:8BBD03>\Temple Generators Restored - Primary Spawns Restored", 5, 3);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/low-level5-bursting.wav');
                  bottomPrint(%client, "<color:8BBD03>\Temple Generators Restored", 5, 3);
               }
            }
            else if (%client.team == Game.offenseTeam)
            {
               messageClient(%client, 'MsgClient', '~wfx/Bonuses/wow-level1-suspended.wav');
               bottomPrint(%client, "<color:FF0000>\Temple Generators Restored", 5, 3);
            }
         }

         //change the spawn weights if objective gens are up
         if (nameToId("ObjectiveGroup").powerCount > 0)
         {
            nameToId("TempleSpawn1").sphereWeight = 100;//--- defense base spawn 1

            //error("Generator::onEnabled - DEFENSE MAY SPAWN AT SPAWN1");

            if (nameToId("AltarSwitch").team == Game.defenseTeam)
            {
               nameToId("AltarDefense").sphereWeight = 100;//--- defense altar spawn

               //error("Generator::onEnabled - DEFENSE MAY SPAWN ALTAR");
            }

            //reset offense altar spawn if they own it
            else
            {
               nameToId("AltarOffense").sphereWeight = 100;
               nameToId("VBaseSpawn").sphereWeight = 10;//---------- offense vbase spawn

               //error("Generator::onEnabled - OFFENSE MAY SPAWN ALTAR");
            }
         }
      }
   }

   // ---------------------------------------------------- Objective Gens
   else if (%obj.getGroup() == nameToId("ObjectiveGroup"))
   {
      if (nameToId("ObjectiveGroup").powerCount < 2)
      {
         //flip the generator waypoint
         game.switchWaypoint(nameToId("ObjectiveGenWaypoint"));

         //send messages
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               if (nameToId("TempleBase").powerCount > 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/med-level3-shining.wav');
                  bottomPrint(%client, "<color:8BBD03>\Shrine Generators Restored - Primary Spawns Restored", 5, 3);
               }
               else
               {
                  messageClient(%client, 'MsgClient', 'low-level4-popping.wav');
                  bottomPrint(%client, "<color:8BBD03>\Shrine Generators Restored", 5, 3);
               }
            }
            else if (%client.team == Game.offenseTeam)
            {
               messageClient(%client, 'MsgClient', '~wfx/Bonuses/low-level1-sharp.wav');
               bottomPrint(%client, "<color:FF0000>\Shrine Generators Restored", 5, 3);
            }
         }

         //change the spawn weights if objective gens are up
         if (nameToId("TempleBase").powerCount > 0)
         {
            nameToId("TempleSpawn1").sphereWeight = 100;//--- defense base spawn 1

            //error("Generator::onEnabled - DEFENSE MAY SPAWN AT SPAWN1");

            if (nameToId("AltarSwitch").team == Game.defenseTeam)
            {
               nameToId("AltarDefense").sphereWeight = 100;//--- defense altar spawn

               //error("Generator::onEnabled - DEFENSE MAY SPAWN AT ALTAR");
            }

            //reset offense altar spawn if they own it
            else
            {
               nameToId("AltarOffense").sphereWeight = 100;
               nameToId("VBaseSpawn").sphereWeight = 10;//---------- offense vbase spawn

               //error("Generator::onEnabled - OFFENSE MAY SPAWN AT ALTAR");
            }
         }
      }
   }
   //---------------------------------------------------------------------- entrance solar panels
   else if (%obj == nameToId("EntranceSolarPanelEast") || %obj == nameToId("EntranceSolarPanelWest"))
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
            bottomPrint(%client, "<color:8BBD03>\Entrance Force Field Restored", 3, 2);
         else if (%client.team == Game.offenseTeam)
            bottomPrint(%client, "<color:FF0000>\Entrance Force Field Restored", 3, 2);
      }
   }
}

//-------------------------------------------------------------------------------------- SiegeGame::halftime ---
function SiegeGame::halftime(%game, %reason)
{
   // z0dd - ZOD, 5/17/02. Clean up deployables triggers
   cleanTriggers(nameToID("MissionCleanup/Deployables"));

   Parent::halftime(%game, %reason);

   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;

   //reset spwan sphere weights
   nameToId("TempleSpawn1").sphereWeight = 100;//--- defense base spawn 1
   nameToId("TempleSpawn2").sphereWeight = 100;//--- defense base spawn 2
   nameToId("AltarDefense").sphereWeight = 100;//--- defense altar spawn
   nameToId("VBaseSpawn").sphereWeight = 100;//---------- offense vbase spawn
   nameToId("AltarOffense").sphereWeight = 0;//----- offense altar spawn

   %flipflop = nameToId("AltarSwitch");//set the name of your flipflop here

   //change the skin on the switch to defense team's logo
   setTargetSkin(%flipflop.getTarget(), game.getTeamSkin(Game.defenseTeam));
   setTargetSensorGroup(%flipflop.getTarget(), Game.defenseTeam);

   Game.claimFlipflopResources(%flipflop, Game.defenseTeam);
   
   //clear bottom print messages
   clearBottomPrintAll();
}

//-------------------------------------------------------------------------------------------- SiegeGame::halftimeOver ---

function SiegeGame::halftimeOver( %game )
{
   // drop all players into mission
   %game.dropPlayers();

   //setup the AI for the second half
   %game.aiHalfTime();
   
   // start the mission again (release players)
   %game.halfTimeCountDown( 0 );

   //redo the objective waypoints
   %game.findObjectiveWaypoints();

   //set up ai vehicle functions for second half - Lagg... 10-2-2003   
   SweepForPads(NameToID(MissionGroup));

   //reset waypoints if nessessary
   if (nameToId("ObjectiveGenWaypoint").team != Game.defenseTeam)
   {
      //error("SiegeGame::halftimeOver - Resetting Shrine Gen Waypoint");
      game.switchWaypoint(nameToId("ObjectiveGenWaypoint"));
   }
   if (nameToId("TempleGenWaypoint").team != Game.defenseTeam)
   {
      //error("SiegeGame::halftimeOver - Resetting Temple Gen Waypoint");
      game.switchWaypoint(nameToId("ObjectiveGenWaypoint"));
   }

   //reset the teleporters holos
   checklogostatus(nameToId("AltarTeleport"));
   checklogostatus(nameToId("TempleTeleport"));
}

function SiegeGame::claimSpawn(%game, %obj, %newTeam, %oldTeam)
{
   // we don't claim spawns with this - Lagg...   
}

//-------------------------------------------------------------------------------------------- SimGroup::housekeeping ---
function SimGroup::housekeeping(%this)
{
   // delete selectively in the MissionCleanup group
   %count = %this.getCount();
   // have to do this backwards or only half the objects will be deleted
   for(%i = (%count - 1); %i > -1; %i--)
   {
      %detritus = %this.getObject(%i);
      if(%detritus.getClassName() $= "SimSet")
      {
         // I don't think there are any simsets we want to delete
      }
      else if(%detritus.getName() $= "PZones")
      {
         // simgroup of physical zones for force fields
         // don't delete them
      }
      //else if (%detritus.getClassName() $= "ScriptObject")
      //{
      // // this will be the game type object.
      // // DEFINITELY don't want to delete this.
      //}
      else if(%detritus.getName() $= PosMarker)
      {
         //Needed to reset non static objects...
      }
      else if((%detritus.getName() $= "TeamDrops1") || (%detritus.getName() $= "TeamDrops2"))
      {
         // this will actually be a SimSet named TeamDropsN (1 or 2)
         // don't want to delete the spawn sphere groups, so do nothing
      }
      else if (%detritus.getName() $= "PlayerListGroup")
      {
         // we don't want to delete PlayerListGroup (SimGroup)
      }
      else if (%detritus.getDatablock().getName() $= "stationTrigger")
      {
         //we don't want to delete triggers for stations
      }
      else if (%detritus.getDatablock().getName() $= "NewTeleportTrigger")
      {
         //we don't want to delete triggers for Sparky's Teleporters
      }
      else if (%detritus.getDatablock().getName() $= "BaseLogo")
      {
         //we don't want to delete team logos for Sparky's Teleporters
      }
      else if (%detritus.getDatablock().getName() $= "BaseBLogo")
      {
         //we don't want to delete team logos for Sparky's Teleporters
      }
      else if (%detritus.getDatablock().getName() $= "StationVehicle")
      {
         // vehicle stations automatically get placed in MissionCleanup in a
         // position near the vehicle pad. Don't delete it.
      }
      else if (%detritus.getClassName() $= "Camera")
      {
         // Cameras should NOT be deleted
      }
      else
      {
         //error("SimGroup::housekeeping - Detritus = " @ %detritus.getDataBlock().getclassName());

         // this group of stuff to be deleted should include:
         // mines, deployed objects, projectiles, explosions, corpses,
         // players, and the like.
         %detritus.delete();
      }
   }
}

//---------------------------------------------------------------------- cleanTriggers ---
// Removes triggers from Siege when players switch sides - called from SiegeGame::halftime
//                                                                  taken from classic mod
function cleanTriggers(%group)
{ 
   if (%group > 0)
      %depCount = %group.getCount();
   else
      return;

   for(%i = 0; %i < %depCount; %i++)
   {
      %deplObj = %group.getObject(%i);
      if(isObject(%deplObj))
      {
         if(%deplObj.trigger !$= "")
         {
            %deplObj.trigger.schedule(0, "delete");
            //error("cleanTriggers - deleting a deployed trigger");
         }
      }
   }
}

//--------------------------------------------------------------------- GameStartUp() ---
function GameStartUp()
{
   $ObjectiveCounter[1] = 0;
   $ObjectiveCounter[2] = 0;
 
   if ($missionRunning == false)
   {
      schedule(500, 0, GameStartUp);
      return;
   }
   SweepForPads(NameToID(MissionGroup)); 
}

//---------------------------------------------------------------------- SweepForPads ---
function SweepForPads(%simGroup)
{
   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;

   if(%SimGroup.getClassName() $= "SimGroup")
   {
      for (%i = 0; %i < %SimGroup.getCount(); %i++)
      {
         %obj = %SimGroup.getObject(%i);
         if (%obj.getClassName() $= "SimGroup")
         {
            SweepForPads(%obj);
         }
 
         if (%obj.getClassName() $= "StaticShape")
         {
            if (%obj.getDataBlock().getName() $= "StationVehicle")
            {
               //addVPadObjective(%obj);
                $AIVehiclePadSet.add(%obj);
            }
            if (%obj.getDataBlock().getName() $= "MPBTeleporter")
            {
               //addVPadObjective(%obj);
               $AIMPBTeleportSet.add(%obj);
            }
            //but the defTeam Holo at mission start and halftime
            if (%obj == nameToId("AltarSwitch"))
            {

               // may have been hidden
               %target = %obj.getTarget();

               // set flipflop to base skin
               setTargetSkin(%target, $teamSkin[Game.defenseTeam]);//set to team skin

               // if there is a "projector" associated with this flipflop, put the claiming team's logo there
               if(%obj.projector > 0)
               {
                  %projector = %obj.projector;
                  // axe the old projected holo, if one exists
                  //if(%projector.holo > 0)
                  if(isObject(%projector.holo))
                     %projector.holo.delete();
          
                  %newHolo = getTaggedString(game.getTeamSkin(Game.defenseTeam)) @ "Logo";

                  %projTransform = %projector.getTransform();
                  // below two functions are from deployables.cs
                  %projRot = rotFromTransform(%projTransform);
                  %projPos = posFromTransform(%projTransform);
                  // place the holo above the projector (default 10 meters)
                  %hHeight = %projector.holoHeight;
                  if(%hHeight $= "")
                     %hHeight = 10;
                  %holoZ = getWord(%projPos, 2) + %hHeight;
                  %holoPos = firstWord(%projPos) SPC getWord(%projPos,1) SPC %holoZ;

                  %holo = new StaticShape() 
                  {
                     rotation = %projRot;
                     position = %holoPos;
                     dataBlock = %newHolo;
                  };
                  // dump the hologram into MissionCleanup
                  MissionCleanup.add(%holo);
                  // associate the holo with the projector
                  %projector.holo = %holo;
                  
                  //error("Setting HOLO PROJECTOR: Defense Team");
               }
            }
         }      
      }
   }
}

//----------------------------------------------------------------------- addVPadObjective ---
function addVPadObjective(%object)
{
   if(%object.team > 0)
   {
      %homeTeam = %object.team;
      if(%homeTeam == 1)
         %enemyTeam = 2;
      else
         %enemyTeam = 1;

      //create the repair objective
      %repairVPad = new AIObjective(AIORepairObject)
                     {
						      dataBlock = "AIObjectiveMarker";
                        weightLevel1 = $AIWeightRepairTurret[1];
                        weightLevel2 = $AIWeightRepairTurret[2];
                        description = "Repair the " @ %object.getDataBlock().getName();
                        targetObject = %object.getDataBlock().getName();
                        targetObjectId = %object;
                        targetClientId = -1;
                        offense = true;
                        equipment = "RepairPack";
								buyEquipmentSet = "MediumRepairSet";
                        location             = %object.getWorldBoxCenter();
		        position	     = %object.getWorldBoxCenter();
                     };
      MissionCleanup.add(%repairVPad);
      $ObjectiveQ[%homeTeam].add(%repairVPad);

      //for siege game we add it twice
     // MissionCleanup.add(%repairVPad);
      //$ObjectiveQ[%enemyTeam].add(%repairVPad);

      //create the mortar objective
      %mortarVPad = new AIObjective(AIOMDestroyObject)
                     {
						      dataBlock = "AIObjectiveMarker";
                        weightLevel1 = $AIWeightRepairTurret[1];
                        weightLevel2 = $AIWeightRepairTurret[2];
                        description = "Mortar the " @ %object.getDataBlock().getName();
                        targetObject = %object.getDataBlock().getName();
                        targetObjectId = %object;
                        targetClientId = -1;
                        offense = true;
                        equipment = "Mortar MortarAmmo";
								buyEquipmentSet = "HeavyAmmoSet";
                        location             = %object.getWorldBoxCenter();
		        position	     = %object.getWorldBoxCenter();
                     };
      MissionCleanup.add(%mortarVPad);
      $ObjectiveQ[%enemyTeam].add(%mortarVPad);

      //for siege game we add it twice
       //MissionCleanup.add(%mortarVPad);
      //$ObjectiveQ[%homeTeam].add(%mortarVPad);
   }
}

//-------------------------------------------------------------------------------------- StaticShapeData::damageObject ---

function StaticShapeData::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   //base items are invincible on offensive team, send a message to all who try
   if (%targetObject.getGroup() == nameToId("VBase"))
   {
      if(%sourceObject && %targetObject.isEnabled())
      {
         //if a player
         if(%sourceObject.client)
            messageClient(%sourceObject.client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
         //a shrike
         else if (%sourceObject.getDataBlock().catagory $= "Vehicles")
         {
            if(%sourceObject.getDatablock().numMountPoints > 0)
            {
               for(%i = 0; %i < %sourceObject.getDatablock().numMountPoints; %i++)
               {
                  if (%sourceObject.getMountNodeObject(%i) > 0)
                     messageClient( %sourceObject.getMountNodeObject(%i).client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
               }
            }
         }
         //or a bomber
         else if(%sourceObject.getDataBlock().getName() $= "BomberTurret")
         {
            %veh = %sourceObject.vehicleMounted;
            if(%veh.getDatablock().numMountPoints > 0)
            {
               for(%i = 0; %i < %veh.getDatablock().numMountPoints; %i++)
               {
                  if (%veh.getMountNodeObject(%i) > 0)
                     messageClient( %veh.getMountNodeObject(%i).client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
               }
            }
         } 
      }

      return;
   }

   Parent::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType);
}

// ---------------------------------------------------------------------------- end AztecTemple_Siege package ---
};






