package LaggsDefault3_GameType {
//--------------------------------------------------------------------------------------- begin package LaggsDefault3_GameType ---***---

//----------------------------------------------------------------------------------------------- Setup ---
function LaggsDefaultSetup()
{
   //
   exec("scripts/LaggsDefault3_mpb.cs");//load the modified mpb functions
   exec("scripts/LaggsDefault3_camera.cs");//exec 1 modified function to fix observer camera spam

   //set mission cleanup for game over ------ * HACK ALERT! - We Hack around MapSupportPack Here :) *
   exec("scripts/LaggsDefault3_MissionOver.cs");//needed to set server back to default while using MapSupportPack

   //if ($Host::BotsEnabled)
   //{
      //%gravity = getGravity();
      //if (%gravity == -20)
      //{
         //error("Server Bots Enabled");
         error("Loading Lagg's... custom AI files :)");

         //exec all the modified ai scripts
         exec("scripts/LaggsDefault3_ai.cs");
         // includes                           exec("scripts/LaggsDefault3_aiDefaultTasks.cs");
         // includes                           exec("scripts/LaggsDefault3_aiObjectives.cs");
         // includes                           exec("scripts/LaggsDefault3_aiInventory.cs");
         // includes                           exec("scripts/LaggsDefault3_aiChat.cs");
         // includes                           exec("scripts/LaggsDefault3_aiObjectiveBuilder.cs");
         // includes                           exec("scripts/LaggsDefault3_serverTasks.cs");
         // includes                           exec("scripts/LaggsDefault3_aiVehicle.cs");//new file - Lagg... 9-30-2003

         //exec all the modifed support files to enhance the ai
         if (Game.class $= "SiegeGame")
            exec("scripts/LaggsDefault3_aiSiege.cs");//exec 2 modified functions from aiSiege.cs
         else if (Game.class $= "CTFGame")
            exec("scripts/LaggsDefault3_aiCTF.cs");//exec 2 modified functions from aiCTF.cs
         else if (Game.class $= "DnDGame")
            exec("scripts/LaggsDefault3_aiDnD.cs");
         exec("scripts/LaggsDefault3_projectiles.cs");//exec 2 modified functions from projectiles.cs
         exec("scripts/LaggsDefault3_player.cs");//exec modified function Armor::onCollision to allow medium bots to pilot vehicles
         exec("scripts/LaggsDefault3_turret.cs");//allows turrets to fire at all enemy targets
         exec("scripts/LaggsDefault3_aiSupport.cs");//2 added functions for mortar/plasma turret fire, 2 spam fixes
         exec("scripts/LaggsDefault3_aiVehicleSupport.cs");//modified bomber/tank data blocks, modified MPB jammer,
                                               //     2 spam fixes for ai dismounting bomber and tank

         activatePackage(LaggsDefault3_Support);
         echo("Activating Package LaggsDefault3_Support");

         LaggsGameStartUp();//call this after Ai files are loaded - NOTE *
      //}
      //else
         //error("Server Gravity not set to default - Aborting Custom AI Setup :(");
   //}
   //else
      //error("Server Bots Disabled - Aborting Custom AI Setup :(");
}


//----------------------------------------------------------------------------------------- end package LaggsDefault2_GameType ---***---
};

//-------------------------------------------------------------------------------------------------------- GameStartUp ---

function LaggsGameStartUp()
{
   $ObjectiveCounter[1] = 0;
   $ObjectiveCounter[2] = 0;
 
   if ($missionRunning == false)
   {
      schedule(500, 0, LaggsGameStartUp);
      return;
   }
   SweepForPads(NameToID(MissionGroup)); 
}

//------------------------------------------------------------------------------------------------------- SweepForPads ---

function SweepForPads(%simGroup)
{
   if(%SimGroup.getClassName() $= "SimGroup")
   {
      for (%i = 0; %i < %SimGroup.getCount(); %i++)
      {
         %obj = %SimGroup.getObject(%i);
         if (%obj.getClassName() $= "SimGroup")
         {
            SweepForPads(%obj);
         }
 
         if (%obj.getClassName() $= "StaticShape")
         {
            if (%obj.getDataBlock().getName() $= "StationVehicle")
            {
               addVPadObjective(%obj);
                $AIVehiclePadSet.add(%obj);
            }
            if (%obj.getDataBlock().getName() $= "MPBTeleporter")
            {
               addTPadObjective(%obj);
               $AIMPBTeleportSet.add(%obj);
            }
         } 
      }
   }
}

//--------------------------------------------------------------------------------------------------- addVPadObjective ---
function addVPadObjective(%object)
{
   if (Game.class $= "SiegeGame")
      Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;
   else
      %homeTeam = %object.team;

   if(%homeTeam == 1)
      %enemyTeam = 2;
   else
      %enemyTeam = 1;

   //create the repair objective
   %repairVPad = new AIObjective(AIORepairObject)
   {
           dataBlock = "AIObjectiveMarker";
           weightLevel1 = $AIWeightRepairTurret[1] + 300;
           weightLevel2 = $AIWeightRepairGenerator[2];
           description = "Repair the " @ %object.getDataBlock().getName();
           targetObject = %object.getDataBlock().getName();
           targetObjectId = %object;
           targetClientId = -1;
           offense = false;
           equipment = "RepairPack";
	   buyEquipmentSet = "MediumRepairSet";
           location             = %object.getWorldBoxCenter();
           position	     = %object.getWorldBoxCenter();
   };

   if (Game.class !$= "SiegeGame")
   {
      //error("MissionCleanup add Repair VPad AIObjective - Default Gameclass");
      //MissionCleanup.add(%repairVPad);
      $ObjectiveQ[%homeTeam].add(%repairVPad);
   }

   else if (%object.team == Game.defenseTeam || 0)
   {
      //error("MissionCleanup add Repair VPad AIObjective - Siege Gameclass");
      //MissionCleanup.add(%repairVPad);
      $ObjectiveQ[Game.defenseTeam].add(%repairVPad);
   }
   else if (%object.team == Game.offenseTeam || 0)
   {
      //error("MissionCleanup add Repair VPad AIObjective - Siege Gameclass");
      //MissionCleanup.add(%repairVPad);
      $ObjectiveQ[Game.offenseTeam].add(%repairVPad);
   }

   MissionCleanup.add(%repairVPad);

   //-------------------------------------------------------------------------
   //create the mortar objective
   %mortarVPad = new AIObjective(AIOMortarObject)
   {
           dataBlock = "AIObjectiveMarker";
           weightLevel1 = $AIWeightMortarVpad[1];
           weightLevel2 = 0;
           description = "Mortar the " @ %object.getDataBlock().getName();
           targetObject = %object.getDataBlock().getName();
           targetObjectId = %object;
           targetClientId = -1;
           offense = true;
           equipment = "Mortar MortarAmmo";
	   buyEquipmentSet = "HeavyAmmoSet";
           location             = %object.getWorldBoxCenter();
           position	     = %object.getWorldBoxCenter();
   };

   if (Game.class !$= "SiegeGame")
   {
      //error("MissionCleanup add Mortar VPad AIObjective - Default Gameclass");
      $ObjectiveQ[%enemyTeam].add(%mortarVPad);
   }

   //if (%object.team == 0)// defense team does not attack offensive base, so only team 0 stuff here
   //{
      //error("MissionCleanup add MDestroy VPad AIObjective");
      //$ObjectiveQ[Game.defenseTeam].add(%mortarVPad);
   //}
   else if (%object.team == Game.defenseTeam)
   {
      //error("MissionCleanup add MDestroy VPad AIObjective - Siege Gameclass");
      $ObjectiveQ[Game.offenseTeam].add(%mortarVPad);
   }

   MissionCleanup.add(%mortarVPad);

   //-------------------------------------------------------------------------
   //create the destroy objective
   %destroyVPad = new AIObjective(AIODestroyObject)
   {
           dataBlock = "AIObjectiveMarker";
           weightLevel1 = $AIWeightDestroyVpad[1];
           weightLevel2 = 0;
           description = "Destroy the " @ %object.getDataBlock().getName();
           targetObject = %object.getDataBlock().getName();
           targetObjectId = %object;
           targetClientId = -1;
           offense = true;
           desiredEquipment = "Plasma PlasmaAmmo";
	   buyEquipmentSet = "HeavyAmmoSet";
           location             = %object.getWorldBoxCenter();
           position	     = %object.getWorldBoxCenter();
   };

   if (Game.class !$= "SiegeGame")
   {
      //error("MissionCleanup add Destroy VPad AIObjective - Default Gameclass");
      $ObjectiveQ[%enemyTeam].add(%destroyVPad);
   }

   //if (%object.team == 0)// defense team does not attack offensive base, so only team 0 stuff here
   //{
      //error("MissionCleanup add Destroy VPad AIObjective");
      //$ObjectiveQ[Game.defenseTeam].add(%destroyVPad);
   //}
   else if (%object.team == Game.defenseTeam)
   {
      //error("MissionCleanup add Destroy VPad AIObjective - Siege Gameclass");
      $ObjectiveQ[Game.offenseTeam].add(%destroyVPad);
   }

   MissionCleanup.add(%destroyVPad);
}

//--------------------------------------------------------------------------------------------------- addTPadObjective ---

function addTPadObjective(%object)
{
   if (Game.class $= "SiegeGame")
      Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;
   else
      %homeTeam = %object.team;
      if(%homeTeam == 1)
         %enemyTeam = 2;
      else
         %enemyTeam = 1;

   //create the repair objective
   %repairVPad = new AIObjective(AIORepairObject)
   {
           dataBlock = "AIObjectiveMarker";
           weightLevel1 = $AIWeightRepairTurret[1] + 50;
           weightLevel2 = $AIWeightRepairGenerator[2];
           description = "Repair the " @ %object.getDataBlock().getName();
           targetObject = %object.getDataBlock().getName();
           targetObjectId = %object;
           targetClientId = -1;
           offense = false;
           equipment = "RepairPack";
	   buyEquipmentSet = "MediumRepairSet";
           location             = %object.getWorldBoxCenter();
           position	     = %object.getWorldBoxCenter();
   };

   if (Game.class !$= "SiegeGame")
   {
      //error("MissionCleanup add Repair TPad AIObjective - Default Gameclass");
      $ObjectiveQ[%homeTeam].add(%repairVPad);
   }

   else if (%object.team == Game.defenseTeam || 0)
   {
      //error("MissionCleanup add Repair TPad AIObjective - Siege Gameclass");
      $ObjectiveQ[Game.defenseTeam].add(%repairVPad);
   }
   else if (%object.team == Game.offenseTeam || 0)
   {
      //error("MissionCleanup add Repair TPad AIObjective - Siege Gameclass");
      $ObjectiveQ[Game.offenseTeam].add(%repairVPad);
   }

   MissionCleanup.add(%repairVPad);
   // ------------------------------------------

   //create the mortar objective
   %mortarVPad = new AIObjective(AIOMortarObject)
   {
           dataBlock = "AIObjectiveMarker";
           weightLevel1 = $AIWeightAttackGenerator[1];
           weightLevel2 = $AIWeightLazeObject[2];
           description = "Mortar the " @ %object.getDataBlock().getName();
           targetObject = %object.getDataBlock().getName();
           targetObjectId = %object;
           targetClientId = -1;
           offense = true;
           equipment = "Mortar MortarAmmo";
	   buyEquipmentSet = "HeavyAmmoSet";
           location             = %object.getWorldBoxCenter();
           position	     = %object.getWorldBoxCenter();
   };

   if (Game.class !$= "SiegeGame")
   {
      //error("MissionCleanup add Mortar TPad AIObjective - Default Gameclass");
      $ObjectiveQ[%enemyTeam].add(%mortarVPad);
   }

   //if (%object.team == 0)// defense team does not attack offensive base, so only team 0 stuff here
   //{
      //error("MissionCleanup add MDestroy TPad AIObjective");
      //$ObjectiveQ[Game.defenseTeam].add(%mortarVPad);
   //}
   else if (%object.team == Game.defenseTeam)
   {
      //error("MissionCleanup add MDestroy TPad AIObjective - Siege Gameclass");
      $ObjectiveQ[Game.offenseTeam].add(%mortarVPad);
   }

   MissionCleanup.add(%mortarVPad);
   // -------------------------------------------

   //create the destroy objective
   %destroyTPad = new AIObjective(AIODestroyObject)
   {
           dataBlock = "AIObjectiveMarker";
           weightLevel1 = $AIWeightRepairGenerator[1];
           weightLevel2 = $AIWeightLazeObject[2];
           description = "Destroy the " @ %object.getDataBlock().getName();
           targetObject = %object.getDataBlock().getName();
           targetObjectId = %object;
           targetClientId = -1;
           offense = true;
           desiredEquipment = "Plasma PlasmaAmmo";
	   buyEquipmentSet = "HeavyAmmoSet";
           location             = %object.getWorldBoxCenter();
           position	     = %object.getWorldBoxCenter();
   };

   if (Game.class !$= "SiegeGame")
   {
      //error("MissionCleanup add Destroy TPad AIObjective - Default Gameclass");
      $ObjectiveQ[%enemyTeam].add(%destroyTPad);
   }

   //if (%object.team == 0)// defense team does not attack offensive base, so only team 0 stuff here
   //{
      //error("MissionCleanup add Destroy TPad AIObjective");
      //$ObjectiveQ[Game.defenseTeam].add(%destroyTPad);
   //}
   else if (%object.team == Game.defenseTeam)
   {
      //error("MissionCleanup add Destroy TPad AIObjective - Siege Gameclass");
      $ObjectiveQ[Game.offenseTeam].add(%destroyTPad);
   }

   MissionCleanup.add(%destroyTPad);
}

