//The scripts in this file are for use only with Aztec Temple Mission. Feel free to use these lines
//as a referrance to study how to give AI more personality and intelligence for a specific mission.
//                                                                                Lagg... 6-22-2004

function SiegeGame::onAIRespawn(%game, %client)
{
   //add the default tasks
	if (! %client.defaultTasksAdded)
	{
		%client.defaultTasksAdded = true;
	   %client.addTask(AIEngageTask);
	   %client.addTask(AIPickupItemTask);
	   //%client.addTask(AITauntCorpseTask);
		%client.addTask(AIEngageTurretTask);
		%client.addtask(AIDetectMineTask);
           %client.addtask(AIDetectRemeqTask);//- Lagg... 3-20-2003
           //%client.addtask(AIDetectVehicleTask);//- Lagg... 11-6-2003
           %client.addTask(AICouldUseInventoryTask);//- Lagg... 9-6-2003
           //%client.addTask(AISpamLocationTask);//- Lagg... 11-16-2003

           //%client.addTask(AIDebugTask);// - for debugging purposes - Lagg...
	}
}

$aiVehicleWaitTime = 65000;
$aiNeedARideTaskTime = 200000;

//////////////////////////////////////////////////////////////////////
//   Modes                             Usages
//___________________________________________________________________
// inField            - aiodestroyobject, aiodeployequipment, aiorepairobject
// inBaseAtt          - aiodestroyobject, aioattackobject
// AltarOwned         - aiodeployequipment, aiorepairobject
// MainGensDown       - aiodeployequipment, aiorepairobject
// ObjGensDown        - aiodefendlocation
// EntFFDown          - aiorepairobject
// EntFFUp            - aiodefendlocation
// MPB                - aiodeployequipment, aiorepairobject
//
//////////////////////////////////////////////////////////////////////


//---------------------------------------------------------------------------------------------- AIO Defend Location ---
//modified so if set to offensive the bot will defend a destroyed enemy object (can you say Camping?) - Lagg... 1/7/2004
//for defense it must be set to defense, for Raping enemy must not have defense > 0 - * IMPORTANT * -

function AIODefendLocation::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   // if were playing CnH, check who owns this
   if (%this.targetObjectId > 0  && %this.defense > 0)
   {
      if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team != %client.team)
         return 0;
   }
   else if (%this.targetObjectId > 0  && %this.offense > 0)
   {
      if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
	      return 0;

      //don't camp unless base is down
      if (%this.targetObjectId.getGroup().powerCount > 0)
         return 0;
   }

   //----------------------------------------------------------------- Aztec Temple extras here ---
   if (%this.mode $= "MainGensDown")
   {
      if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && !%client.inBase)
         return 0;
   }
   if (%this.mode $= "ObjGensDown")
   {
      if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && !%client.inBase)
         return 0;
   }
   else if (%this.mode $= "EntFFUp")
   {
      if (nameToId("EastEntFFGroup").powerCount <= 0 || nameToId("WestEntFFGroup").powerCount <= 0 || %client.inBase)
         return 0;
   }
   //-------------------------------------------------------------------------- End extras --------

   //do a quick check to disqualify this objective if it can't meet the minimum weight
   if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
   {
      if (%this.targetObjectId > 0 && %this.issuedByClientId == %client.controlByHuman)
      {
         if ($AIWeightHumanIssuedCommand < %minWeight)
	    return 0;
      }
      else
         return 0;
   }

   %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);

   //if defensive the object has been destroyed, reduce the weight/if offensive increase the weight if destroyed (Camping !)
   if (%this.targetObjectId > 0 && %this.defense > 0)
   {

      //see if we were forced on the objective
      if (%this.issuedByClientId == %client.controlByHuman && %weight < $AIWeightHumanIssuedCommand)
         %weight = $AIWeightHumanIssuedCommand;

      //else see if the object has been destroyed - slight modification here - Lagg... 11-7-2003
      //else if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      else if (!isObject(%this.targetObjectId) || %this.targetObjectId.isDisabled())
         %weight -= 320;
   }
   else if (%this.targetObjectId > 0 && %this.offense > 0)
   {

      //see if we were forced on the objective
      if (%this.issuedByClientId == %client.controlByHuman && %weight < $AIWeightHumanIssuedCommand)
         %weight = $AIWeightHumanIssuedCommand;

      //don't camp if not destroyed - slight modification here - Lagg... 11-7-2003
      else if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() !$= "Destroyed")
         return 0;
      if (%client.player.getInventory("InventoryDeployable") > 0)
         return 0;
   }
   return %weight;
}

//--------------------------------------------------------------------------------------- AIOPilotShrike::weight ---
//Set up to 10 simgroups called "T" @ %team @ "ShrikePath" @ %num
//(example T2ShrikePath1 to T2ShrikePath10 / T1ShrikePath1 to T1ShrikePath10)
//NOTE: must start with number 1 and count in order up to 10
//inside these simgroups place markers in the order to follow for each
//path. Thats 1 simgroup per path for each team - Lagg... 4-8-2004
//* NOTE *
//Give this guy plenty of room with the markers, he flys like a wild man :)

function AIOPilotShrike::weight(%this, %client, %level, %minWeight, %inventoryStr)
{   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //check if flight path exists
   if (Game.class $= "SiegeGame")
      %team = Game.offenseTeam == %client.team ? 1 : 2;
   else
      %team = %client.team;

   if(! isObject(nameToId("T" @ %team @ "ShrikePath1")))
      return 0;

   //do a quick check to disqualify this objective if it can't meet the minimum weight
   if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
   {
      if (%this.targetObjectId > 0 && %this.issuedByClientId == %client.controlByHuman)
      {
         if ($AIWeightHumanIssuedCommand < %minWeight)
	    return 0;
      }
      else
         return 0;
   }

   //check for Vehicle station near buy of forget it if we are not mounted yet or didn't just buy - Lagg...
   if (!%client.player.isMounted() && !%client.justBought)
   {
      %clVs = AIFindClosestVStation(%client);
      if (%clVs > 0)
      {
         %closestVs = getWord(%clVs, 0);
         %closestVsDist = getWord(%clVs, 1);
         if (%closestVsDist > 300)//----------------------* close to VPad or return 0 *---
            return 0;
      }
      else
         return 0;

      //check if any of vehicle type are availible
      %blockName = "ScoutFlyer";
      if (!vehicleCheck(%blockName, %client.team))
         return 0;
   }

   //never bump a shrike pilot from his ride
   if (%this.clientLevel1 > 0  && %level == 1 && %this.clientLevel1 != %client)
      return 0;
   else if (%this.clientLevel1 == %client)
      return 20000;

   //----------------------------------------------------------------- Aztec Temple extras here ---

   //check for deployed MPB
   %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
   %closestMPB = getWord(%result, 0);

   //if the mpb is deployed and we own the altar forget this task     
   if (%closestMPB > 0)
   {
      if (nameToId("AltarSwitch").team == %client.team)
      return 0;
   }
   //-------------------------------------------------------------------------- End extras --------

   return AIODefault::weight(%this, %client, %level, %inventoryStr);
}

//-------------------------------------------------------------------------------------------------- AIO Bombing Run ---
//Place AIO Objective Marker in the spot you want pilot to park and wait for passegers
//Set up to 10 simgroups called "T" @ %team @ "BomberPath" @ %num
//(example T2BomberPath1 to T2BomberPath10 / T1BomberPath1 to T1BomberPath10)
//NOTE: must start with number 1 and count in order up to 10
//inside these simgroups place markers in the order to follow for each
//path. Thats 1 simgroup per path (up to 10) for each team - Lagg... 4-8-2004

function AIOBombingRun::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //do a quick check to disqualify this objective if it can't meet the minimum weight
   if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
   {
      if (%this.targetObjectId > 0 && %this.issuedByClientId == %client.controlByHuman)
      {
         if ($AIWeightHumanIssuedCommand < %minWeight)
	    return 0;
      }
      else
         return 0;
   }

   //check for Vehicle station near buy of forget it if we are noy mounted yet - Lagg...
   //would like to add a check for unpiloted vehicles with passengers that need a ride (someday)
   if (!%client.player.isMounted() && !%client.justBought)
   {
      %clVs = AIFindClosestVStation(%client);
      if (%clVs > 0)
      {
         %closestVs = getWord(%clVs, 0);
         %closestVsDist = getWord(%clVs, 1);
         if (%closestVsDist > 300)//----------------------* close to VPad or return 0 *---
            return 0;
      }
      else
         return 0;

      //check if any of vehicle type are availible
      %blockName = "BomberFlyer";
      if (!vehicleCheck(%blockName, %client.team))
         return 0;
   }

   %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);

   //never bump a pilot off his ride
   if (%this.clientLevel1 > 0  && %level == 1 && %this.clientLevel1 != %client)
      return 0;
   else if (%this.clientLevel1 == %client)
      return 10000;

   //----------------------------------------------------------------- Aztec Temple extras here ---

   //if the entrance solar panels are down forget this task
   if (nameToId("EastEntFFGroup").powerCount <= 0 && nameToId("WestEntFFGroup").powerCount <= 0)
         return 0;
   //-------------------------------------------------------------------------- End extras --------

   return %weight;
}

//---------------------------------------------------------------------------------------------- AI Attack Object ---

function AIAttackObject::initFromObjective(%task, %objective, %client)
{
   %task.baseWeight = %client.objectiveWeight;
   %task.targetObject = %objective.targetObjectId;
   %task.equipment = %objective.equipment;
   %task.buyEquipmentSet = %objective.buyEquipmentSet;
   %task.desiredEquipment = %objective.desiredEquipment;
   %task.issuedByClient = %objective.issuedByClientId;
   %task.location = %objective.location;

   //follow path - Lagg...
   %task.followPath = false;

   //initialize other task vars
   %task.sendMsg = true;
   %task.sendMsgTime = 0;

   //MPB Telepoter
   %task.useTeleport = false;

   //Sparky's Teleporters
   %task.useTele = false;
   %task.tele = -1;
}

function AIAttackObject::assume(%task, %client)
{
   %task.setWeightFreq(50);//was 15
   %task.setMonitorFreq(50);//was 15

   //added here so Bot buys a random set if specified in objective dataBlock - Lagg... 2-14-2003
      if (%task.buyEquipmentSet $= "randomSet")
      {
         //pick a random equipment set...
         %randNum = getRandom();
         if (%randNum < 0.2)
         {
            %task.desiredEquipment = "Plasma PlasmaAmmo";
            %task.buyEquipmentSet = "HeavyEnergySet";
         }
         else if (%randNum < 0.4)
         {
            %task.desiredEquipment = "Plasma PlasmaAmmo";
            %task.buyEquipmentSet = "MediumEnergySet";
         } 
         else if (%randNum < 0.6)
         {
            %task.desiredEquipment = "Plasma PlasmaAmmo";
            %task.buyEquipmentSet = "LightCloakSet";
         }
         else if (%randNum < 0.8)
         {
            %task.desiredEquipment = "Plasma PlasmaAmmo";
            %task.buyEquipmentSet = "HeavyShieldOff";
         }
         else
         {
            %task.desiredEquipment = "Plasma PlasmaAmmo";
            %task.buyEquipmentSet = "MediumMissileSet";
         }
      }

   if (%task.equipment !$= "")
      %equipmentList = %task.equipment;
   else
      %equipmentList = %task.desiredEquipment;
   %client.needEquipment = AINeedEquipment(%equipmentList, %client);

   //even if we don't *need* equipemnt, see if we should buy some... 
   if (!%client.needEquipment && %task.buyEquipmentSet !$= "")
   {
      //see if we could benefit from inventory
      %needArmor = AIMustUseRegularInvStation(%task.desiredEquipment, %client);
      %result = AIFindClosestInventory(%client, %needArmor);
      %closestInv = getWord(%result, 0);
      %closestDist = getWord(%result, 1);
      if (AINeedEquipment(%task.desiredEquipment, %client) && %closestInv > 0)
      {
         //find where we are
         %clientPos = %client.player.getWorldBoxCenter();
         %objPos = %task.targetObject.getWorldBoxCenter();
         %distToObject = %client.getPathDistance(%objPos);

	 if (%distToObject < 0 || %closestDist < 25)//-------- 25m or less to inventoryStation in this case
            %client.needEquipment = true;
      }
   }

   //mark the current time for the buy inventory state machine
   %task.buyInvTime = getSimTime();


   if (!%client.inBase)
   {
      %result = aiTeleporterCheck(%client, %task.targetObject);
      %task.useTele = getWord(%result, 0);//true or false
      %task.tele = getWord(%result, 1);//this is the linked tele to use
   }

   //--------------------------------------------------- follow paths ---
   //if (!%client.inBase && !%task.useTele)
   if (!%client.inBase)
   {
      //set the destination paths for each team and game type
   
      //first see how many paths we have
      //check if the path exists
      if (Game.class $= "SiegeGame")
         %team = Game.offenseTeam == %client.team ? 1 : 2;
      else
         %team = %client.team;

      %mx = 0;
      for(%i = 1; %i < 10; %i++)
      {
         if(isObject(nameToId("T" @ %team @ "AttackPath" @ %i)))
            %mx = %i;
      }

      //error("AIAttackObject::assume - # of Paths = " @ %mx);

      //%name = %task.targetObject.getName();
      if (%mx > 0)
      {
         %random = mFloor(getRandom(1, %mx));

         // - set the path simgroup to follow
         %task.group = nameToId("T" @ %team @ "AttackPath" @ %random);
         %task.count = %task.group.getCount();  
         %task.locationIndex = 0;

         //make sure there are markers in the AttackPath group
         if (%task.count > 0)
            %task.followPath = true;
      }
   }

   //--------------------------------------------------- assume telporter - start -
   //if the MPB Teleporter is online - Lagg... 9-30-2003

   //first check for deployed MPB
   %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
   %closestMPB = getWord(%result, 0);
   %closestMPBDist = getWord(%result, 1);
      
   //next find the teleporter
   %result = SweepForTeleporters(%client);//new function in aiVehicle.cs
   %closestTel = getWord(%result, 0);
   %closestTelDist = getWord(%result, 1);
      
   //now check for what would be closer - Lagg... 10-1-2003
   if (%closestMPB > 0 && %closestTel > 0)
   {
      %disToTarg = %client.getPathDistance(%task.targetObject.getTransform());
      %mpbDisToTarg = vectorDist(%closestMPB.getTransform(), %task.targetObject.getTransform());
         
      if (%closestTelDist < %closestMPBDist && %closestMPBDist < %disToTarg && %mpbDisToTarg < %disToTarg)
         %task.useTeleport = true;//new - Lagg... 10-1-2003
      else
         %task.useTeleport = false;             
   }
   //--------------------------------------------------- assume telporter - end -

   //error("AIAttackObject::assume - client = " @ getTaggedString(%client.name));//more debugging
}

function AIAttackObject::monitor(%task, %client)
{
   //--------------------------------------------------- monitor telporter - start -
   //are we using teleporter
   if (%task.useTeleport)
   {
      %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
      %closestMPB = getWord(%result, 0);
      %closestMPBDist = getWord(%result, 1);
      %result = SweepForTeleporters(%client);//new function in aiVehicle.cs
      %closestTel = getWord(%result, 0);
      %closestTelDist = getWord(%result, 1);
      if (%closestMPB > 0 && %closestTel > 0)
      {
         //we are done teleporting
         if (%closestMPBDist < %closestTelDist)
         {
            //reset the clients inventory status
            if (%client.needEquipment)
            {
               %result = AIFindClosestInventory(%client, 0);
	       %closestInv = getWord(%result, 0);
               %client.invToUse = %closestInv;
            }
            %task.useTeleport = false;
            return;
         }

         if (%closestTelDist < 2)
            %client.pressJump();
         else
         {
            %client.stepMove(%closestTel.getWorldBoxCenter(), 0.25, $AIModeWalk);
            return;
         }
      }
      else
         %task.useTeleport = false;
   }
   //--------------------------------------------------- monitor telporter - end -

   //first, buy the equipment - if we really really need some :) - Lagg... - 4-6-2003
   %hasMortar = (%client.player.getInventory("Mortar") > 0) && (%client.player.getInventory("MortarAmmo") > 0);
   %hasPlasma = (%client.player.getInventory("Plasma") > 0) && (%client.player.getInventory("PlasmaAmmo") > 0);
   %hasDisc = (%client.player.getInventory("Disc") > 0) && (%client.player.getInventory("DiscAmmo") > 0) && (!%client.player.getInventory("Blaster") > 0);
   if (%hasMortar || %hasPlasma || %hasDisc)
      %client.needEquipment = false;

   //first, buy the equipment - if we really really need some :) - Lagg... - 4-6-2003
   if (%client.needEquipment)
   {
      %task.setMonitorFreq(5);
      if (%task.equipment !$= "")
         %equipmentList = %task.equipment;
      else
         %equipmentList = %task.desiredEquipment;
      %result = AIBuyInventory(%client, %equipmentList, %task.buyEquipmentSet, %task.buyInvTime);
      if (%result $= "InProgress")
         return;
      else if (%result $= "Finished")
      {
         %task.setMonitorFreq(50);//was 15
	 %client.needEquipment = false;
      }
      else if (%result $= "Failed")
      {
         //if this task is the objective task, choose a new objective
	 if (%task == %client.objectiveTask)
	 {
	    AIUnassignClient(%client);
	    Game.AIChooseGameObjective(%client);
	 }
         return;
      }
   }

   //if we made it past the inventory buying, reset the inv time
   %task.buyInvTime = getSimTime();
   
   //chat
   if (%task.sendMsg)
   {
      if (%task.sendMsgTime == 0)
         %task.sendMsgTime = getSimTime();
      else if (getSimTime() - %task.sendMsgTime > 7000)
      {
         %task.sendMsg = false;
         if (%client.isAIControlled())
         {
	    if (%task.chat !$= "")
	    {
	       %chatMsg = getWord(%task.chat, 0);
	       %chatTemplate = getWord(%task.chat, 1);
	       if (%chatTemplate !$= "")
	          AIMessageThreadTemplate(%chatTemplate, %chatMsg, %client, -1);
	       else
		  AIMessageThread(%task.chat, %client, -1);
            }
	    else if (%task.targetObject > 0)
	    {
	       %type = %task.targetObject.getDataBlock().getName();
	       if (%type $= "GeneratorLarge")
	          AIMessageThreadTemplate("AttackBase", "ChatSelfAttackGenerator", %client, -1);
	       else if (%type $= "SensorLargePulse")
		  AIMessageThreadTemplate("AttackBase", "ChatSelfAttackSensors", %client, -1);
	       else if (%type $= "SensorMediumPulse")
		  AIMessageThreadTemplate("AttackBase", "ChatSelfAttackSensors", %client, -1);
	       else if (%type $= "TurretBaseLarge")
		  AIMessageThreadTemplate("AttackBase", "ChatSelfAttackTurrets", %client, -1);
	       else if (%type $= "StationVehicle")
		  AIMessageThreadTemplate("AttackBase", "ChatSelfAttackVehicle", %client, -1);
            }
         }
      }
   }


   //set the target object if targetObject not destroyed
   %outOfStuff = (AIAttackOutofAmmo(%client));
   if (isObject(%task.targetObject) && %task.targetObject.getDamageState() !$= "Destroyed" && !%outOfStuff)
   {
      //if we are using Sparky's teleporters
      if (%task.useTele)
      {
         %pos = %client.player.position;
         %dest = %task.tele.position;

         //are we close to location index marker?
         if (VectorDist(%dest, %pos) < 1.5 || %client.inBase)//1.5 meters from linked tele
         {
            %task.useTele = false;
            return;
         }
         else
         {
            //error("AIAttackObject::monitor - WE ARE USING THE TELEPORTER - " @ getTaggedString(%client.name));
            %client.stepMove(%task.tele.position, 0.25, $AIModeExpress);
         }
      }

      else if (%task.followPath)
      {
         //error("AIAttackObject::monitor - Following Path - " @ getTaggedString(%client.name));

         //set the path and follow it to the end
         %task.spot = %task.group.getObject(%task.locationIndex).position;

         %pos = %client.player.position;
         %dest = %task.spot;

         //are we close to location index marker?
         if (VectorDist(%dest, %pos) < 1.5)//1.5 meters from marker
         {
            //if we have another location index
            if ((%task.count - 1) > %task.locationIndex)//has to be -1 on the groups count
               %task.locationIndex++;
            //else we are at end of trail
            else
            {
               //if this task is the objective task, choose a new objective
	       if (%task == %client.objectiveTask)
	       {
	          %task.followPath = false;
	          return;
               }
            }
         }
         else
            %client.stepMove(%task.spot, 0.25, $AIModeExpress);
      }
      else
         %client.stepMove(%task.location, 0.25, $AIModeExpress);//move to target

      %targetLOS = "false";
      %mask = $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType;
      %targetLOS = !containerRayCast(%client.player.getMuzzlePoint($WeaponSlot), %task.targetObject.getWorldBoxCenter(), %mask, 0);

      %close = false;
      if (VectorDist(%task.targetObject.position, %client.player.position) < 5)
         %close = true;
      
      //fire at target object if in sight
      if (%targetLOS && !%close)
      {
         %task.setWeight($AIWeightReturnFire);
         %client.setEngageTarget(-1);
         %client.setTargetObject(%task.targetObject, 100, "Mortar");
      }
      else
      {
         %client.setTargetObject(-1);
         %task.setWeight(%task.baseWeight);

         //see if we need to engage a new target
         %engageTarget = %client.getEngageTarget();
         if (!AIClientIsAlive(%engageTarget) && %task.engageTarget > 0)
            %client.setEngageTarget(%task.engageTarget);

         //else see if we should abandon the engagement
         else if (AIClientIsAlive(%engageTarget))
         {
            %myPos = %client.player.getWorldBoxCenter();
            %testPos = %engageTarget.player.getWorldBoxCenter();
            %distance = %client.getPathDistance(%testPos);
            if (%distance < 0 || %distance > 20)
               %client.setEngageTarget(-1);

            //see if we're supposed to be engaging anyone...
            if (!AIClientIsAlive(%client.getEngageTarget()) && AIClientIsAlive(%client.shouldEngage))
               %client.setEngageTarget(%client.shouldEngage);
         }
      } 
   }
   else
   {
      %client.setTargetObject(-1);      
            
      //if this task is the objective task, choose a new objective
      if (%task == %client.objectiveTask)
      {
         //if we need to repair self, aim at the floor
         if (%client.player.getDamagePercent() > 0 && %client.player.getInventory(RepairPack) > 0)
         {
            %pos = %client.player.getWorldBoxCenter();
            %posX = getWord(%pos, 0);
            %posY = getWord(%pos, 1);
            %posZ = getWord(%pos, 2) - 1;
            %pos = %posX SPC %posY SPC %posZ;
            %client.aimAt(%pos, 500);
         }
         AIUnassignClient(%client);
         Game.AIChooseGameObjective(%client);
      }
   }
}

//----------------------------------------------------------------------------------------------- AIO Repair Object ---

function AIORepairObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team != %client.team)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //special checks to see if we are in base or a paticular gen is up/down
   if (%this.mode $= "MPB")
   {
      if (%client.inBase)
         return 0;

      //check for deployed MPB
      %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
      %closestMPB = getWord(%result, 0);

      if (%closestMPB > 0)
      {
         if (VectorDist(%this.position, %closestMPB.position) > 150)
            return 0;
      }
      else
         return 0; 
   }
   else if (%this.mode $= "inField")
   {
      if (%client.inBase)
         return 0;
   }
   else if (%this.mode $= "EntFFDown")
   {
      if (nameToId("WestEntFFGroup").powerCount > 0 && nameToId("EastEntFFGroup").powerCount > 0  && !%client.inBase)
         return 0;
   }
   else if (%this.mode $= "MainGensDown")//this sets up inventory and turrets if gens are down
   {
      if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0  && !%client.inBase)
         return 0;

      if (nameToId("TempleBase").powerCount > 0)
         return 0;
   }
   else if (%this.mode $= "ObjectiveGensDown")
   {
      if (nameToId("WestEntFFGroup").powerCount > 0 && nameToId("EastEntFFGroup").powerCount > 0 && !%client.inBase)
         return 0;

      if (nameToId("ObjectiveGroup").powerCount > 0)
         return 0;
   }
   else if (%this.mode $= "EntFFUp")//------------------ if Def SolarPanels are down forget it -*- "EntSpUp"
   {
      if (nameToId("EastEntFFGroup").powerCount <= 0 && nameToId("WestEntFFGroup").powerCount <= 0)
         return 0;
   }
   else if (%this.mode $= "AltarOwned")
   {
      if (nameToId("AltarSwitch").team != %client.team || %client.inBase)
         return 0;
   }
      
   //no need to repair if the object isn't in need
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamagePercent() <= 0)
      return 0;
   else
	{
		//if this bot is linked to a human who has issued this command, up the weight
		if (%this.issuedByClientId == %client.controlByHuman)
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
			{
				if ($AIWeightHumanIssuedCommand < %minWeight)
					return 0;
				else
					%weight = $AIWeightHumanIssuedCommand;
			}
			else
			{
				// calculate the default...
				%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
				if (%weight < $AIWeightHumanIssuedCommand)
					%weight = $AIWeightHumanIssuedCommand;
			}
		}
		else
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
				return 0;

			// calculate the default...
			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
		}

		return %weight;
	}
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ AIO Deploy Equipment +++
//modified here so bot will continue deploying if has equip and not get bumped
//can be set at a realistic weight now, like 3400               - Lagg... 4-12-2003
//If the function ShapeBaseImageData::testInvalidDeployConditions() changes at all, those changes need to be reflected here

function AIODeployEquipment::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //make sure the deploy objective is valid
   if (%this.isInvalid)
      return 0;

   //if badly damaged and we have a repair pack, don't waste time
   %damage = %client.player.getDamagePercent();
   if (%client.player.getInventory("RepairPack") > 0 && %damage > 0.3)
      return 0;


   //---------------------------- special checks to see if we are in base or a paticular gen is up/down  --
   if (%this.mode $= "MPB")
   {
      if (%client.inBase)
         return 0;

      //check for deployed MPB
      %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
      %closestMPB = getWord(%result, 0);

      if (%closestMPB > 0)
      {
         if (VectorDist(%this.position, %closestMPB.position) > 150)
            return 0;
      }
      else
         return 0; 
   }
   else if (%this.mode $= "inField")//---------------------------------------------------------------------------- if client is in base forget it -*- "inField"
   {
      if (%client.inBase)
         return 0;
   }
   else if (%this.mode $= "EntFFUp")//---------------------------------------------------------------- if Def SolarPanels are down forget it -*- "EntSpUp"
   {
      if (nameToId("EastEntFFGroup").powerCount <= 0 && nameToId("WestEntFFGroup").powerCount <= 0)
         return 0;
   }
   else if (%this.mode $= "EntFFDown")//this sets up sensor and turret by solar panel
   {
      if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && !%client.inBase)
         return 0;
   }
   else if (%this.mode $= "inBaseAtt")//this sets up inventories inside base
   {
      if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && !%client.inBase)
         return 0;
   }
   else if (%this.mode $= "MainGensDown")//this sets up inventory and turrets if gens are down
   {
      if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0  && !%client.inBase)
         return 0;

      if (nameToId("TempleBase").powerCount > 0)
         return 0;
   }
   else if (%this.mode $= "AltarOwned")
   {
      if (nameToId("AltarSwitch").team != %client.team || %client.inBase)
         return 0;
   }

   //first, make sure we haven't deployed too many...
   if (%this.equipment $= "TurretOutdoorDeployable" || %this.equipment $= "TurretIndoorDeployable")
      %maxAllowed = countTurretsAllowed(%this.equipment);
   else
      %maxAllowed = $TeamDeployableMax[%this.equipment];

   if ($TeamDeployedCount[%client.team, %this.equipment] >= %maxAllowed)
      return 0;

   //now make sure there are no other items in the way...
   InitContainerRadiusSearch(%this.location, $MinDeployableDistance, $TypeMasks::VehicleObjectType |
  	                                             $TypeMasks::MoveableObjectType |
  	                                             $TypeMasks::StaticShapeObjectType |
  	                                             $TypeMasks::TSStaticShapeObjectType | 
  	                                             $TypeMasks::ForceFieldObjectType |
  	                                             $TypeMasks::ItemObjectType | 
  	                                             $TypeMasks::PlayerObjectType | 
  	                                             $TypeMasks::TurretObjectType);
      %objSearch = containerSearchNext();

      //make sure we're not invalidating the deploy location with the client's own player object
      if (%objSearch == %client.player)
         %objSearch = containerSearchNext();

      //did we find an object which would block deploying the equipment?
      if (isObject(%objSearch))
         return 0;

   //now run individual checks based on the equipment type...
   if (%this.equipment $= "TurretIndoorDeployable")
   {
      //check if there's another turret close to the deploy location
      InitContainerRadiusSearch(%this.location, $TurretIndoorSpaceRadius, $TypeMasks::StaticShapeObjectType);
      %found = containerSearchNext();
      if (isObject(%found))
      {
         %foundName = %found.getDataBlock().getName();
 	 if ((%foundName $= TurretDeployedFloorIndoor) || (%foundName $= "TurretDeployedWallIndoor") ||
           (%foundName $= "TurretDeployedCeilingIndoor") || (%foundName $= "TurretDeployedOutdoor"))
 	    return 0;
      }
 
      //now see if there are too many turrets in the area...
      %highestDensity = 0;
      InitContainerRadiusSearch(%this.location, $TurretIndoorSphereRadius, $TypeMasks::StaticShapeObjectType);
      %found = containerSearchNext();
      while (isObject(%found))
      {
         %foundName = %found.getDataBlock().getName();
 	 if ((%foundName $= "TurretDeployedFloorIndoor") || (%foundName $= "TurretDeployedWallIndoor") ||
           (%foundName $= "TurretDeployedCeilingIndoor") || (%foundName $= "TurretDeployedOutdoor"))
 	 {
 	    //found one
 	    %numTurretsNearby++;//+++++++++++++++++++++++++++++++++++++++++ ahh review this - Lagg... +++
            %nearbyDensity = testNearbyDensity(%found, $TurretIndoorSphereRadius);
 	    if (%nearbyDensity > %highestDensity)
 	       %highestDensity = %nearbyDensity;
         }
 	 %found = containerSearchNext();
      }
 
      if (%numTurretsNearby > %highestDensity)
         %highestDensity = %numTurretsNearby;
 
      //now see if the area is already saturated
      if (%highestDensity > $TurretIndoorMaxPerSphere)
         return 0;
   }
   else if (%this.equipment $= "TurretOutdoorDeployable")
   {
      //check if there's another turret close to the deploy location
      InitContainerRadiusSearch(%this.location, $TurretOutdoorSpaceRadius, $TypeMasks::StaticShapeObjectType);
      %found = containerSearchNext();
      if (isObject(%found))
      {
         %foundName = %found.getDataBlock().getName();     
         if ((%foundName $= "TurretDeployedFloorIndoor") || (%foundName $= "TurretDeployedWallIndoor") || (%foundName $= "TurretDeployedCeilingIndoor") || (%foundName $= "TurretDeployedOutdoor"))
            return 0;
      }
 
      //now see if there are too many turrets in the area...
      %highestDensity = 0;
      InitContainerRadiusSearch(%this.location, $TurretOutdoorSphereRadius, $TypeMasks::StaticShapeObjectType);
      %found = containerSearchNext();
      while (isObject(%found))
      {
         %foundName = %found.getDataBlock().getName();
 	 if ((%foundName $= "TurretDeployedFloorIndoor") || (%foundName $= "TurretDeployedWallIndoor") || (%foundName $= "TurretDeployedCeilingIndoor") || (%foundName $= "TurretDeployedOutdoor"))
 	 {
 	    //found one
 	    %numTurretsNearby++;
 
 	    %nearbyDensity = testNearbyDensity(%found, $TurretOutdoorSphereRadius);
 	    if (%nearbyDensity > %highestDensity)
 	       %highestDensity = %nearbyDensity;     
 	 }
 	 %found = containerSearchNext();
      }
 
      if (%numTurretsNearby > %highestDensity)
         %highestDensity = %numTurretsNearby;
 
      //now see if the area is already saturated
      if (%highestDensity > $TurretOutdoorMaxPerSphere)
         return 0;
   }

   //check equipment requirement
   %needEquipment = AINeedEquipment(%this.equipment, %client);
   %needArmor = AIMustUseRegularInvStation(%this.equipment, %client);
   %result = AIFindClosestInventory(%client, %needArmor);
   %closestInv = getWord(%result, 0);
   %closestDist = getWord(%result, 1);
   if (%client.team == Game.offenseTeam && %needEquipment && %closestDist > 200)
   {
      %itemType = getWord(%this.requiredEquipment, 0);
      %found = false;
      %itemCount = $AIItemSet.getCount();
      for (%i = 0; %i < %itemCount; %i++)
      {
         %item = $AIItemSet.getObject(%i);
  	 if (%item.getDataBlock().getName() $= %itemType && !%item.isHidden())
  	 {
	    %weightDist = %client.getPathDistance(%item.getWorldBoxCenter());
	    if (%weightDist > 0 && %weightDist < 200)
	    {
	       //%weightInv = %item;  //set the var so the distance function will work...
	       %found = true;
	       break;
	    }
         }
      }
      if (!%found)
         return 0; 
   }
	
   //if we don't need equipment, see if we've past the "point of no return", and should continue regardless
   if (! %needEquipment && %this.clientLevel1 == %client)
   {
      //if we're too far from the inv to go back, or we're too close to the deploy location, force continue
      //if (%closestDist > 50 && VectorDist(%client.player.getWorldBoxCenter(), %task.location) < 50) - modified Lagg...
      if (%closestDist > 25)
      {
         %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
 	 if (%weight < $AIWeightContinueDeploying)
 	    %weight = $AIWeightContinueDeploying;

         return %weight;
      }
   }

   //if this bot is linked to a human who has issued this command, up the weight
   if (%this.issuedByClientId == %client.controlByHuman)
   {
      //make sure we have the potential to reach the minWeight
      if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
      {
         if ($AIWeightHumanIssuedCommand < %minWeight)
            return 0;
	 else
            %weight = $AIWeightHumanIssuedCommand;
      }
      else
      {
         // calculate the default...
         %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	 if (%weight < $AIWeightHumanIssuedCommand)
	    %weight = $AIWeightHumanIssuedCommand;
      }
   }
   else
   {
      //make sure we have the potential to reach the minWeight
      if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
         return 0;

      // calculate the default...
      %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
   }
   if (%needEquipment && !%needArmor && %closestDist > 200)
   {
      %found = false;
      %itemType = getWord(%this.requiredEquipment, 0);
      %itemCount = $AIItemSet.getCount();
      for (%i = 0; %i < %itemCount; %i++)
      {
         %item = $AIItemSet.getObject(%i);
  	 if (%item.getDataBlock().getName() $= %itemType && !%item.isHidden())
  	 {
	    %weightDist = %client.getPathDistance(%item.getWorldBoxCenter());
	    if (%weightDist > 0 && %weightDist < 200)
	    {
	       //%weightInv = %item;  //set the var so the distance function will work...
	       %found = true;
	       break;
	    }
         }
      }
      if (%found)
         %weight = $AIWeightContinueDeploying + 100;
      else
      // calculate the default...
         %weight = AIODefault::weight(%this, %client, %level, %inventoryStr); 
   }
   else
      // calculate the default...
      %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);

	return %weight;
}

//---------------------------------------------------------------------------------------------------- AIO Attack Object ---
//totally rewritten so but will RAPE the object. used only for generators in siege - Lagg... 11-1-2003
function AIOAttackObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;
      
   //no need to attack if the object is already destroyed
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;

   else
   {
      //if this bot is linked to a human who has issued this command, up the weight
      if (%this.issuedByClientId == %client.controlByHuman)
      {
         //make sure we have the potential to reach the minWeight
	 if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	 {
	    if ($AIWeightHumanIssuedCommand < %minWeight)
	       return 0;
	    else
	       %weight = $AIWeightHumanIssuedCommand;
         }
	 else
	 {
	    // calculate the default...
	    %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	    if (%weight < $AIWeightHumanIssuedCommand)
	       %weight = $AIWeightHumanIssuedCommand;
	 }
      }
      else
      {
         //make sure we have the potential to reach the minWeight
	 if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	    return 0;

	 // calculate the default...
	 %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
      }

      //lets give him some personallity on this one :) - Lagg...
      if ((findTargetInView(%client, 150)) == %this.targetObjectId)
                   %weight += 400;

      if (%client.inBase)
         %weight += 200;
      //----------------------------------------------------------------------- Zone Checks
      else if (%this.description $= "Attack the GeneratorLarge")//-- if attacking gens and entFF are Up and we are not in base adn we don't own the altar forget it -*- "GenAtt"
      {
         if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && nameToId("AltarSwitch").team != %client.team && !%client.inBase)
         //if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && !%client.inBase)
            return 0;
      }
      //-------------------------------------------------------------------------------------

      return %weight;
   }
}



//----------------------------------------------------------------------------------------------- AIO Destroy Object ---
//place objective marker in spot you want bot to stand and destroy for sentry turrets and hard to
//reach spots. basically same as attackobject, use this on generators/solar panels in siege game - Lagg... 3-26-2003

function AIODestroyObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;
      
   //no need to attack if the object is already destroyed
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;

   //-------------------------------------------------------------------------------------------------- Zone Checks ---------
   if (%this.mode $= "inField")
   {
      //if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && nameToId("AltarSwitch").team != %client.team && !%client.inBase)
      if (%client.inBase)
         return 0;
   }
   else if (%this.mode $= "inBaseAtt")
   {
      //if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && nameToId("AltarSwitch").team != %client.team && !%client.inBase)
      if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && !%client.inBase)
         return 0;
   }
   //--------------------------------------------------------------------------------------------------- End Zones ----------

   //if this bot is linked to a human who has issued this command, up the weight
   if (%this.issuedByClientId == %client.controlByHuman)
   {
      //make sure we have the potential to reach the minWeight
      if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
      {
         if ($AIWeightHumanIssuedCommand < %minWeight)
            return 0;
	 else
	    %weight = $AIWeightHumanIssuedCommand;
      }
      else
      {
         // calculate the default...
	 %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	 if (%weight < $AIWeightHumanIssuedCommand)
	    %weight = $AIWeightHumanIssuedCommand;
      }
   }
   else
   {
      //make sure we have the potential to reach the minWeight
      if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
         return 0;

      // calculate the default...
      %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
   }

   ////lets give him some personallity on this one :) - Lagg...
   //if ((findTargetInView(%client, 150)) == %this.targetObjectId)
      //%weight += 400;

   return %weight;
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ AIO Escort Player +++
//modified escorter armor type allowed, rewritten all aivehicle escort stuff, included vehicleobjecttypes
//as potential targets if lazed by escortie.                                              - Lagg... - 4-12-2003

function AIOEscortPlayer::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client) || ! AIClientIsAlive(%this.targetClientId))
      return 0;

   //can't escort yourself
   if (%client == %this.targetClientId)
      return 0;

   //if vehicle mounted escort check for empty seats - Lagg... - 5-17-2003
   //%targMounted = %this.targetClientId.player.ismounted();
   if (%this.targetClientId.player.ismounted())
   {
      //%this.forceClientId = %client;//this should stop em getting bumped
      %vehicle = %this.targetClientId.vehicleMounted;
      %node = findAIEmptySeat(%vehicle, %client.player);

      if (%node < 0 && %client.vehicleMounted != %this.targetClientId.vehicleMounted)
         return 0;

      //lets keep bombardiers, gunners in their seats
      else if (%client.vehicleMounted == %this.targetClientId.vehicleMounted)
         return 10000;

      //zone check
      if (%client.inBase)
         return 0;
   }

   //make sure the class is appropriate unless we are in a vehicle :) - Lagg...
   if (%this.forceClientId <= 0 && %this.issuedByClientId != %client.controlByHuman)
   {
      %targArmor = %this.targetClientId.player.getArmorSize();
      %myArmor = %client.player.getArmorSize();
      %targMounted = %this.targetClientId.player.ismounted();
                      
      //if ((%targArmor $= "Light" && %myArmor !$= "Light" && !%targMounted)
        //|| (%targArmor $= "Medium" && %myArmor $= "Heavy" && !%targMounted))
	      //return 0;

      //changed here to allow bigger escorts - Lagg... 1-31-2003
      if (%targArmor $= "Light" && %myArmor $= "Heavy" && !%targMounted)
	      return 0;
   }

   //can't bump a forced client from level 1
   if (%this.forceClientId > 0 && %this.forceClientId != %client && %level == 1)
      return 0;

   //lets check the range on this one if not forced from command map
   if (%this.forceClientId <= 0 && vectorDist(%client.Player.getWorldBoxCenter(), %this.targetClientId.player.getWorldBoxCenter()) > 200)
      return 0;

   //if this bot is linked to a human who has issued this command, up the weight
   if (%this.issuedByClientId == %client.controlByHuman)
   {
      //make sure we have the potential to reach the minWeight
		if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
		{
			if ($AIWeightHumanIssuedEscort < %minWeight)
				return 0;
			else
				%weight = $AIWeightHumanIssuedEscort;
		}
		else
		{
			// calculate the default...
			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
			if (%weight < $AIWeightHumanIssuedEscort)
				%weight = $AIWeightHumanIssuedEscort;
		}
	}
	else
	{
		//make sure we have the potential to reach the minWeight
		if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
			return 0;

		// calculate the default...
		%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	}

	return %weight;
}

//----------------------------------------------------------------------------------------------- AIO Laze Object ---
//fixed here so bots will acually use the targetting lazer for the right team :) - Lagg... - 4-12-2003
//modified last laze time and distance to client we laze for.
   
function AIOLazeObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //if we are in water forget it
   if (%client.inWater)
      return 0;

   //not if we are in the base
   if (%client.inBase)
      return 0;

   //lets check the range on this one
   if (vectorDist(%client.Player.getWorldBoxCenter(), %this.targetObjectId.getWorldBoxCenter()) < 100)
      return 0;
      
	//see if it's already being lazed
	%numTargets = ServerTargetSet.getCount();
	for (%i = 0; %i < %numTargets; %i++)
	{
		%targ = ServerTargetSet.getObject(%i);
		if (%targ.sourceObject != %client.player)
		{
			%targDist = VectorDist(%targ.getWorldBoxCenter(), %this.targetObjectId.getWorldBoxCenter());
			if (%targDist < 10)
			{
				%this.lastLazedTime = getSimTime();
				%this.lastLazedClient = %targ.sourceObject.client;
				break;
 			}
		}
	}
   if (%this.issuedByClientId > 0 && %this.issuedByClinetId == %client)
   {
       echo("cant laze target for your self IDIOT !");
       return 0;
   }

   //no need to laze if the object is already destroyed
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;
	else if (%this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;      
	else if (getSimTime() - %this.lastLazedTime <= 10000 && %this.lastLazedClient == %client)
		return 0;
   else
	{
	   //set the base weight
	   switch (%level)
	   {
	      case 1:
	         %weight = %this.weightLevel1;
	      case 2:
	         %weight = %this.weightLevel2;
	      case 3:
	         %weight = %this.weightLevel3;
	      default:
	         %weight = %this.weightLevel4;
	   }
   
	   //check Affinity
	   if (ClientHasAffinity(%this, %client))
	      %weight += 100;
      
		//for now, do not deviate from the current assignment to laze a target, if you don't
		//already have a targeting laser.
		%needEquipment = AINeedEquipment(%this.equipment, %client);
		if (!%needEquipment)
			%weight += 100;
		else if (!aiHumanHasControl(%client.controlByHuman, %client))
			return 0;

		//see if this client is close to the issuing client
		if (%this.issuedByClientId > 0)
		{
			if (! AIClientIsAlive(%this.issuedByClientId))
				return 0;

		   %distance = %client.getPathDistance(%this.issuedByClientId.player.getWorldBoxCenter());
			if (%distance < 0)
				%distance = 32767;

		   //see if we're over 300 m
		   if (%distance > 300)
		      return 0;

                   //see if we're within 200 m
		   if (%distance < 200)
		      %weight += 30;

		   //see if we're within 90 m
		   if (%distance < 90)
		      %weight += 30;

		   //see if we're within 45 m
		   if (%distance < 45)
		      %weight += 30;
		}

		//now, if this bot is linked to a human who has issued this command, up the weight
		if (%this.issuedByClientId == %client.controlByHuman && %weight < $AIWeightHumanIssuedCommand)
			%weight = $AIWeightHumanIssuedCommand;

		return %weight;
	}
}

//----------------------------------------------------------------------------------------------- AIO Missile Object ---
//                                                                                              - Lagg... 4-12-2003
function AIOMissileObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //check the zone
   if (%client.inBase)
      return 0;

   //lets check the range on this one
   if (vectorDist(%client.Player.getWorldBoxCenter(), %this.getWorldBoxCenter()) < 50)
      return 0;
    
   //no need to attack if the object is already destroyed
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;
   else
	{
		//if this bot is linked to a human who has issued this command, up the weight
		if (%this.issuedByClientId == %client.controlByHuman)
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
			{
				if ($AIWeightHumanIssuedCommand < %minWeight)
					return 0;
				else
					%weight = $AIWeightHumanIssuedCommand;
			}
			else
			{
				// calculate the default...
				%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
				if (%weight < $AIWeightHumanIssuedCommand)
					%weight = $AIWeightHumanIssuedCommand;
			}
		}
		else
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
				return 0;

			// calculate the default...
			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
		}

		return %weight;
	}
}

//----------------------------------------------------------------------------------------------- AIO Mortar Object ---
//Modified so bot gets LOS to target before firing. Fixed a lot of stuff here.          - Lagg...

function AIOMortarObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //check the zone
   if (%client.inBase)
      return 0;

   //lets check the range on this one
   if (vectorDist(%client.Player.getWorldBoxCenter(), %this.targetObjectId.getWorldBoxCenter()) < 100)
      return 0;

   //check equipment requirement
   %needEquipment = AINeedEquipment(%this.equipment, %client);
   %needArmor = AIMustUseRegularInvStation(%this.equipment, %client);
   %result = AIFindClosestInventory(%client, %needArmor);
   %closestInv = getWord(%result, 0);
   %closestDist = getWord(%result, 1);

   if (%client.team == Game.offenseTeam && %closestDist > 100 && (%needArmor || %needEquipment))
      return 0;
      
   //no need to attack if the object is already destroyed
   if (%this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;
   else
   {
      //if this bot is linked to a human who has issued this command, up the weight
      if (%this.issuedByClientId == %client.controlByHuman)
      {
         //make sure we have the potential to reach the minWeight
	 if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	 {
	    if ($AIWeightHumanIssuedCommand < %minWeight)
	       return 0;
	    else
	       %weight = $AIWeightHumanIssuedCommand;
	 }
	 else
	 {
	    // calculate the default...
	    %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	    if (%weight < $AIWeightHumanIssuedCommand)
	       %weight = $AIWeightHumanIssuedCommand;
         }
      }
      else
      {
         //make sure we have the potential to reach the minWeight
         if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	    return 0;

	 // calculate the default...
         %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
      }

      return %weight;
   }
}

//modified client escorter - Lagg... - 4-12-2003
function AIOMortarObject::assignClient(%this, %client)
{
   %client.objectiveTask = %client.addTask(AIMortarObject);
   %client.objectiveTask.initFromObjective(%this, %client);
   
   //create the escort objective (require a targeting laser in this case...)
   %client.escort = new AIObjective(AIOEscortPlayer)
                     {
						      dataBlock = "AIObjectiveMarker";
                        weightLevel1 = $AIWeightEscortOffense[1];
                        weightLevel2 = $AIWeightEscortOffense[2];
                        description = "Escort " @ getTaggedString(%client.name);
                        targetClientId = %client;
                        offense = true;
                        equipment = "Plasma PlasmaAmmo TargetingLaser";
								buyEquipmentSet = "MediumMissileSet";
                     };
   MissionCleanup.add(%client.escort);

   //if is siege game we have to do this right - Lagg... 11-3-2003
   if (Game.class $= "SiegeGame")
   {
      //the objectives in $ObjectiveQ[1] are all offense objectives, $ObjectiveQ[2] has the defensive ones..
      if (%client.team == game.offenseTeam)
         $ObjectiveQ[1].add(%client.escort);
      else
         $ObjectiveQ[2].add(%client.escort);
   }
   else
      $ObjectiveQ[%client.team].add(%client.escort);
}

//--------------------------------------------------------------------------------------------------- AIO Touch Object ---

function AIOTouchObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //-------------------------------------------------------------------- Zone Check ---
   if (%this.targetObjectId == nameToId("AltarSwitch") && %client.inBase)
      return 0; 

   if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
      return 0;

   switch$ (%this.mode)
   {
      case "TouchFlipFlop":
         if(%this.targetObjectId.team == %client.team || %this.targetObjectId.isHidden())
	    return 0;

         //added a check for siege games to enhance the ai, fix navGraph bug with forcefileds
         //check if ff is up around switch, if so don't do task - Lagg...
         else if ($CurrentMissionType $= "Siege")
         {
            //-------------------------------------------------------------------------- Zone Check ---
            //if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 &&
              //nameToId("AltarSwitch").team != %client.team && !%client.inBase)
            if (nameToId("EastEntFFGroup").powerCount > 0 && nameToId("WestEntFFGroup").powerCount > 0 && !%client.inBase)
               return 0;

            InitContainerRadiusSearch(%this.location, 12, $TypeMasks::ForceFieldObjectType);
            %objSearch = containerSearchNext();
            if (%objSearch > 0 && %objSearch.isPowered() && %objSearch.team != %client.team)
               return 0;
         }
         //----------------------------------------------------------------------------- End Zones ---

	 %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);

         if (%client.inBase)
            %weight += 200;

         return %weight;

      case "FlagGrab":
			if (! %this.targetObjectId.isHome)
				return 0;
			else
	         return AIODefault::weight(%this, %client, %level, %inventoryStr);
      case "FlagDropped":
			if ((%this.targetObjectId.isHome) || (%this.targetObjectId.carrier !$= ""))
				return 0;
			else
	         return AIODefault::weight(%this, %client, %level, %inventoryStr);
      case "FlagCapture":
			if (%this.targetObjectId.carrier != %client.player)
            return 0;
         else
			{
				//find our home flag location
				%homeTeam = %client.team;
				%homeFlag = $AITeamFlag[%homeTeam];
				%this.location = %homeFlag.originalPosition;
				return AIODefault::weight(%this, %client, %level, %inventoryStr);
			}
   }
   return 0;
}

// -------------------------------------------------------------------------------------------

function AIONeedARide::assignClient(%this, %client)
{
   %client.objectiveTask = %client.addTask(AINeedARide);
   %client.objectiveTask.initFromObjective(%this, %client);

   //create the escort objectives

   //pick a random equipment set...
   %randNum = getRandom();
   if (%randNum < 0.2)
   {
      %equip = "";
      %desEquip = "PlasmaPlasmaAmmo";
      %set = "HeavyEnergySet";
   }
   else if (%randNum < 0.4)
   {
      %equip = "InventoryDeployable";
      %desEquip = "";
      %set = "HeavyInventorySet";
   } 
   else if (%randNum < 0.6)
   {
      %equip = "";
      %desEquip = "AmmoPack";
      %set = "HeavyAmmoSet";
   }
   else if (%randNum < 0.8)
   {
      %equip = "";
      %desEquip = "ShieldPack";
      %set = "HeavyShieldOff";
   }
   else
   {
      %equip = "InventoryDeployable";
      %desEquip = "";
      %set = "MediumInventorySet";
   }

   %client.escort = new AIObjective(AIOEscortPlayer)
                     {
						      dataBlock = "AIObjectiveMarker";
                        weightLevel1 = 5000;//set high - lagg...
                        weightLevel2 = 0;
                        description = "Escort " @ getTaggedString(%client.name);
                        targetClientId = %client;
                        offense = true;
                        chat = "ChatNeedHold";
                        desiredEquipment = "FlareGrenade";
								buyEquipmentSet = "HeavyRepairSet";
                     };

   %client.escort1 = new AIObjective(AIOEscortPlayer)
                     {
						      dataBlock = "AIObjectiveMarker";
                        weightLevel1 = 5000;
                        weightLevel2 = 0;
                        description = "Escort " @ getTaggedString(%client.name);
                        targetClientId = %client;
                        offense = true;
                        chat = "ChatNeedRide";
                        equipment = %equip;
                        desiredEquipment = %desEquip;
								buyEquipmentSet = %set;
                     };

   //pick a random equipment set...
   %randNum = getRandom();
   if (%randNum < 0.3)
   {
      %equip = "InventoryDeployable";
      %desEquip = "";
      %set = "HeavyInventorySet";
   }
   else if (%randNum < 0.5)
   {
      %equip = "";
      %desEquip = "PlasmaPlasmaAmmo";
      %set = "MediumShieldSet";
   } 
   else if (%randNum < 0.6)
   {
      %equip = "";
      %desEquip = "SensorJammerPack";
      %set = "HeavyEnergySet";
   }
   else if (%randNum < 0.8)
   {
      %equip = "";
      %desEquip = "ShieldPack";
      %set = "HeavyShieldOff";
   }
   else
   {
      %equip = "";
      %desEquip = "AmmoPack";
      %set = "MediumMissileSet";
   }

   %client.escort2 = new AIObjective(AIOEscortPlayer)
                     {
						      dataBlock = "AIObjectiveMarker";
                        weightLevel1 = 5000;
                        weightLevel2 = 0;
                        description = "Escort " @ getTaggedString(%client.name);
                        targetClientId = %client;
                        offense = true;
                        chat = "ChatNeedRide";
                        equipment = %equip;
                        desiredEquipment = %desEquip;
								buyEquipmentSet = %set;
                     };

   MissionCleanup.add(%client.escort);
   MissionCleanup.add(%client.escort1);
   MissionCleanup.add(%client.escort2);

   //if is siege game we have to do this right - Lagg... 11-3-2003
   if (Game.class $= "SiegeGame")
   {
      //the objectives in $ObjectiveQ[1] are all offense objectives, $ObjectiveQ[2] defense
      if (%client.team == game.offenseTeam)
      {
         $ObjectiveQ[1].add(%client.escort);
         $ObjectiveQ[1].add(%client.escort1);
         $ObjectiveQ[1].add(%client.escort2);
      }
      else
      {
         $ObjectiveQ[2].add(%client.escort);
         $ObjectiveQ[2].add(%client.escort1);
         $ObjectiveQ[2].add(%client.escort2);
      }
   }
   else
   {
         $ObjectiveQ[%client.team].add(%client.escort);
         $ObjectiveQ[%client.team].add(%client.escort1);
         $ObjectiveQ[%client.team].add(%client.escort2);
   }
}

//--------------------------------------------------------------------------------------------------------------
function AIConnection::onAIConnect(%client, %name, %team, %skill, %offense, %voice, %voicePitch)
{
   // Sex/Race defaults
   %client.sex = "Male";
   %client.race = "Human";
   %client.armor = "Light";

   //setup the voice and voicePitch
   if (%voice $= "")
      %voice = "Bot1";
   %client.voice = %voice;
   %client.voiceTag = addTaggedString(%voice);
   
   if (%voicePitch $= "" || %voicePitch < 0.5 || %voicePitch > 2.0)
      %voicePitch = 1.0;
	%client.voicePitch = %voicePitch;

   %client.name = addTaggedString( "\cp\c9" @ %name @ "\co" );
	%client.nameBase = %name;

   echo(%client.name);
   echo("CADD: " @ %client @ " " @ %client.getAddress());
   $HostGamePlayerCount++;
   
   //set the initial team - Game.assignClientTeam() should be called later on...
   %client.team = %team;
   if ( %client.team & 1 )
      %client.skin = addTaggedString( "basebot" );
   else
      %client.skin = addTaggedString( "basebbot" );

	//setup the target for use with the sensor net, etc...
   %client.target = allocClientTarget(%client, %client.name, %client.skin, %client.voiceTag, '_ClientConnection', 0, 0, %client.voicePitch);
   
   //i need to send a "silent" version of this for single player but still use the callback  -jr`
   if($currentMissionType $= "SinglePlayer")
		messageAllExcept(%client, -1, 'MsgClientJoin', "", %name, %client, %client.target, true);
   else
	   messageAllExcept(%client, -1, 'MsgClientJoin', '\c1%1 joined the game.', %name, %client, %client.target, true);

	//assign the skill
	%client.setSkillLevel(%skill);
	
	//assign the affinity
   %client.offense = %offense;
    
   //clear any flags
   %client.stop(); // this will clear the players move state
   %client.clearStep();
   %client.lastDamageClient = -1;
   %client.lastDamageTurret = -1;
   %client.setEngageTarget(-1);
   %client.setTargetObject(-1);
   %client.engageRemeq = -1;//added - Lagg...
   %client.pickUpItem = -1;//added - Lagg...
   %client.objective = "";

   //reset the client zone flags for mission No Quarter  - Lagg... 12-17-2003
   %client.inBase = false;
   //%client.inRoom = false;

	//clear the defaulttasks flag
	%client.defaultTasksAdded = false;

	//if the mission is already running, spawn the bot
   if ($missionRunning)
      %client.startMission();
}

//-----------------------------------------------------------------------------------------------------------------------
function onAIRespawn(%client)
{
   %markerObj = Game.pickPlayerSpawn(%client, true);
   Game.createPlayer(%client, %markerObj);	

	//make sure the player object is the AI's control object - even during the mission warmup time
	//the function AISystemEnabled(true/false) will control whether they actually move...
	%client.setControlObject(%client.player);
   
   if (%client.objective)
      error("ERROR!!! " @ getTaggedString(%client.name) @ " is still assigned to objective: " @ %client.objective.getName());
      
   //clear the objective and choose a new one
	AIUnassignClient(%client);
   %client.stop();
   %client.clearStep();
   %client.lastDamageClient = -1;
   %client.lastDamageTurret = -1;
   %client.shouldEngage = -1;
   %client.setEngageTarget(-1);
   %client.setTargetObject(-1);
   %client.engageRemeq = -1;//added - Lagg...
   %client.pickUpItem = -1;//added - Lagg...
	%client.pilotVehicle = false;

   //reset the client zone flags for mission Fumarole  - Lagg... 6-22-2004
   %client.inBase = false;

	//set the spawn time
	%client.spawnTime = getSimTime();
	%client.respawnThread = "";

	//timeslice the objective reassessment for the bots
	if (!isEventPending(%client.objectiveThread))
	{
		%curTime = getSimTime();
		%remainder = %curTime % 5000;
		%schedTime = $AITimeSliceReassess - %remainder;
		if (%schedTime <= 0)
			%schedTime += 5000;
		%client.objectiveThread = schedule(%schedTime, %client, "AIReassessObjective", %client);

		//set the next time slice "slot"
		$AITimeSliceReassess += 300;
		if ($AITimeSliceReassess > 5000)
			$AITimeSliceReassess -= 5000;
	}

	//call the game specific spawn function
	Game.onAIRespawn(%client);
}

//-----------------------------------------------------------------------------------------------------------------------
function AIMissionEnd()
{
	//disable the AI system
	AISystemEnabled(false);

	//loop through the client list, and clear the tasks of each bot
	%count = ClientGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%client = ClientGroup.getObject(%i);
		if (%client.isAIControlled())
		{
			//cancel the respawn thread and the objective thread...
			cancel(%client.respawnThread);
			cancel(%client.objectiveThread);

         //reset the clients tasks, variables, etc...
	      AIUnassignClient(%client);
         %client.stop();
			%client.clearTasks();
         %client.clearStep();
         %client.lastDamageClient = -1;
         %client.lastDamageTurret = -1;
         %client.shouldEngage = -1;
         %client.setEngageTarget(-1);
         %client.setTargetObject(-1);
         %client.engageRemeq = -1;//added - Lagg...
         %client.pickUpItem = -1;//added - Lagg...
	      %client.pilotVehicle = false;
         %client.defaultTasksAdded = false;

         //reset the client zone flags - Lagg... 12-17-2003
         %client.inBase = false;

	      //do the nav graph cleanup
	      %client.missionCycleCleanup();
		}
	}

	//clear the objective Q's
	for (%i = 0; %i <= Game.numTeams; %i++)
	{
		if (isObject($ObjectiveQ[%i]))
		{
			$ObjectiveQ[%i].clear();
			$ObjectiveQ[%i].delete();
		}
		$ObjectiveQ[%i] = "";
	}

	//now delete all the sets used by the AI system...
	if (isObject($AIBombLocationSet))
   	$AIBombLocationSet.delete();
	$AIBombLocationSet = "";

	if (isObject($AIInvStationSet))
   	$AIInvStationSet.delete();
	$AIInvStationSet = "";

	if (isObject($AIItemSet))
   	$AIItemSet.delete();
	$AIItemSet = "";

	if (isObject($AIGrenadeSet))
   	$AIGrenadeSet.delete();
	$AIGrenadeSet = "";

	if (isObject($AIWeaponSet))
   	$AIWeaponSet.delete();
	$AIWeaponSet = "";

	if (isObject($AIRemoteTurretSet))
   	$AIRemoteTurretSet.delete();
	$AIRemoteTurretSet = "";

	if (isObject($AIDeployedMineSet))
   	$AIDeployedMineSet.delete();
	$AIDeployedMineSet = "";

	if (isObject($AIVehicleSet))
   	$AIVehicleSet.delete();
	$AIVehicleSet = "";

        //get rid of the aivehiclepadset as well ----------------------------------------- added Lagg... - 8-19-2003
        if (isObject($AIVehiclePadSet))
   	$AIVehiclePadSet.delete();
	$AIVehiclePadSet = "";

        //get rid of the aiteleportset as well ----------------------------------------- added Lagg... - 10-1-2003
        if (isObject($AITeleportSet))
   	$AITeleportSet.delete();
	$AITeleportSet = "";
}
